/* xfleet.c  by M.Dobashi 1999.8.8~ */
/* $Id: xfleet.c,v 1.5 2006/07/21 08:40:41 mit Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <X11/Xlib.h>
#include <X11/Xlocale.h>
#include <X11/cursorfont.h>

#define  fnc(a, b, c)  a + b * cos(.01745 * (c + 90))
#define  fnb(a, b, c)  a + b * sin(.01745 * (c + 90))
#define  fnx(a, b)     a - b + 82
#define  fny(a, b)     a - b + 50
#define  fnh(x, y, a)  y - 5 *(a - x)
#define  fni(x, y, a)  y -.2 *(a - x)
#define  fnj(k, s, z)  k / (1 -.45 *(s - z) / s)
#define	 rnd()	rand()/2147483647.1

#define	 MAXK   22
#define	 HIKO   11
#define	 EXE    -1
#define	 END 	-2
#define	 QUI	-3
#define	 TOP	1
#define	 SEC	2
#define	 SRD	3
#define	 ALL	4
#define	 KOMA	18
#define	 COMM	9
#define  BUT    14
#define	 TOG	2
#define	 KATI	13
#define	 X	14
#define	 Y	15
#define	 SYU	16
#define	 COD	4
#define	 NEN	4
#define	 MEI	3
#define	 YUU	2
#define	 KOU	1
#define	 TAI	0
#define	 ALG	1
#define	 PRT	0
#define	 AIRP	1
#define	 GYRY	0
#define	 YUSO	300
#define	 NORMAL	1
#define	 REVERS	0
#define	 b_w	8
#define	 b_h	6

Display *disp;
Window	wind;
Window	butto[KOMA];
Window	comma[COMM];
Window	ws, wk, wc, wt, wr, wf, wp, wm, wi;
Window	butt[BUT];
Window	togl[TOG];
Window	code[COD];
Cursor	curs, curs_m;
GC gc, rgc, fgc;
XFontSet fs;
XFontStruct *fontst;
Pixmap px_a, px_b, px_c, px_d, px_e, px_f, px_g, px_h, px;
Pixmap ax_a, ax_b, ax_c, ax_d, ax_e, ax_f, ax_g, ax_h;

char font_name[] = "9x15bold";
char bf[100];
char buff[100];

char *b_name[] = { "","","","","","","","",
                   "","","",""," OK","Quit",};

char *c_name[] = { "Move","Skip","Photo","Map","Fight",
                   "ADC","Data","File","Quit",};

char *f_name[] = {"",""," OK","Cancel",};

static unsigned char b_b[] = { 0x0c,0x12,0x21,0xc0,0x00,0x00 };

static unsigned char f_bship_bits[] = {
  0x10, 0x00, 0x38, 0x00, 0x7c, 0x00, 0xfe, 0x00, 0xd6, 0x00, 0xd7, 0x01,
  0xff, 0x01, 0xd7, 0x01, 0xd7, 0x01, 0xff, 0x01, 0xff, 0x01, 0xff, 0x01,
  0xff, 0x01, 0x7d, 0x01, 0xff, 0x01, 0x7d, 0x01, 0xff, 0x01, 0xff, 0x01,
  0x7d, 0x01, 0xff, 0x01, 0x7d, 0x01, 0xff, 0x01, 0xff, 0x01, 0xff, 0x01,
  0xff, 0x01, 0xff, 0x01, 0xd7, 0x01, 0xd7, 0x01, 0xfe, 0x00, 0x38, 0x00};

static unsigned char f_fship_bits[] = {
  0x08, 0x1c, 0x3e, 0x2a, 0x6b, 0x7f, 0x7f, 0x5d, 0x7f, 0x7f, 0x5d, 0x7f,
  0x7f, 0x5d, 0x7f, 0x7f, 0x6b, 0x6b, 0x3e, 0x1c};

static unsigned char f_subm_bits[] = {
  0x02, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x05, 0x05, 0x07, 0x07, 0x07,
  0x07, 0x07, 0x07, 0x02};

static unsigned char f_bort_bits[] = {
  0x02, 0x07, 0x05, 0x05, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07};

static unsigned char f_baship_bits[] = {
  0xfc, 0x00, 0x02, 0x01, 0x02, 0x01, 0x01, 0x02, 0x01, 0x02, 0x01, 0x02,
  0x01, 0x02, 0x01, 0x02, 0x01, 0x02, 0x01, 0x02, 0x01, 0x02, 0x01, 0x02,
  0x01, 0x03, 0x01, 0x03, 0x01, 0x03, 0x01, 0x03, 0x01, 0x02, 0x01, 0x02,
  0x01, 0x02, 0x01, 0x02, 0x01, 0x02, 0x01, 0x02, 0x01, 0x02, 0x01, 0x02,
  0x01, 0x02, 0x03, 0x03, 0xfe, 0x01};

static unsigned char f_laship_bits[] = {
  0xfc, 0x00, 0x02, 0x01, 0x02, 0x01, 0x01, 0x02, 0x01, 0x02, 0x01, 0x02,
  0x01, 0x02, 0x01, 0x02, 0x01, 0x03, 0x01, 0x03, 0x01, 0x03, 0x01, 0x02,
  0x01, 0x02, 0x01, 0x02, 0x01, 0x02, 0x01, 0x02, 0x03, 0x03, 0xfe, 0x01};

static unsigned char f_yship_bits[] = {
  0x0c, 0x1e, 0x3f, 0x3f, 0x33, 0x3f, 0x2d, 0x3f, 0x2d, 0x3f, 0x3f, 0x3f,
  0x3f, 0x3f, 0x3f, 0x1e};

static unsigned char f_airp_bits[] = {
  0x04, 0x1f, 0x04, 0x04, 0x0e};

static unsigned char a_bship_bits[] = {
  0x38, 0x00, 0xfe, 0x00, 0xd7, 0x01, 0xd7, 0x01, 0xff, 0x01, 0xff, 0x01,
  0xff, 0x01, 0xff, 0x01, 0xff, 0x01, 0x7d, 0x01, 0xff, 0x01, 0x7d, 0x01,
  0xff, 0x01, 0xff, 0x01, 0x7d, 0x01, 0xff, 0x01, 0x7d, 0x01, 0xff, 0x01,
  0xff, 0x01, 0xff, 0x01, 0xff, 0x01, 0xd7, 0x01, 0xd7, 0x01, 0xff, 0x01,
  0xd7, 0x01, 0xd6, 0x00, 0xfe, 0x00, 0x7c, 0x00, 0x38, 0x00, 0x10, 0x00};

static unsigned char a_fship_bits[] = {
  0x1c, 0x3e, 0x6b, 0x6b, 0x7f, 0x7f, 0x5d, 0x7f, 0x7f, 0x5d, 0x7f, 0x7f,
  0x5d, 0x7f, 0x7f, 0x6b, 0x2a, 0x3e, 0x1c, 0x08};

static unsigned char a_subm_bits[] = {
  0xfa, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfd, 0xfd, 0xff, 0xff,
  0xff, 0xff, 0xff, 0xfa};

static unsigned char a_bort_bits[] = {
  0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x05, 0x05, 0x07, 0x02};

static unsigned char a_baship_bits[] = {
  0xfe, 0x01, 0x03, 0x03, 0x01, 0x02, 0x01, 0x02, 0x01, 0x02, 0x01, 0x02,
  0x01, 0x02, 0x01, 0x02, 0x01, 0x02, 0x01, 0x02, 0x01, 0x02, 0x01, 0x02,
  0x03, 0x02, 0x03, 0x02, 0x03, 0x02, 0x03, 0x02, 0x01, 0x02, 0x01, 0x02,
  0x01, 0x02, 0x01, 0x02, 0x01, 0x02, 0x01, 0x02, 0x01, 0x02, 0x01, 0x02,
  0x02, 0x01, 0x02, 0x01, 0xfc, 0x00};

static unsigned char a_laship_bits[] = {
  0xfe, 0x01, 0x03, 0x03, 0x01, 0x02, 0x01, 0x02, 0x01, 0x02, 0x01, 0x02,
  0x01, 0x02, 0x01, 0x02, 0x03, 0x02, 0x03, 0x02, 0x03, 0x02, 0x01, 0x02,
  0x01, 0x02, 0x01, 0x02, 0x01, 0x02, 0x02, 0x01, 0x02, 0x01, 0xfc, 0x00};

static unsigned char a_yship_bits[] = {
  0x1e, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x2d, 0x3f, 0x2d, 0x3f, 0x33,
  0x3f, 0x3f, 0x1e, 0x0c};

static unsigned char a_airp_bits[] = {
  0x0e, 0x04, 0x04, 0x1f, 0x04};

unsigned rikuN[30][2] = {
  70,1,70,80,100,80,100,40,120,40,120,20,140,20,
  140,80,180,80,180,60,210,60,210,30,230,30,230,
  50,220,50,220,60,260,60,260,20,290,20,290,90,
  310,90,310,20,360,20,360,60,410,60,410,30,420,
  30,420,40,450,40,450,1, };

unsigned rikuS[40][2] = {
  70,500,70,460,80,460,80,420,90,420,90,450,
  140,450,140,440,160,440,160,420,180,420,180,460,
  200,460,200,440,210,440,210,470,220,470,220,490,
  270,490,270,480,320,480,320,460,280,460,280,450,
  310,450,310,430,320,430,320,420,330,420,330,460,
  340,460,340,410,380,410,380,460,400,460,400,420,
  440,420,440,460,450,460,450,500, };

unsigned sima[25][2] = {
  240,240,240,250,230,250,230,260,226,260,226,
  266,230,266,230,274,250,274,250,278,262,278,262,
  280,270,280,270,270,280,270,280,264,284,264,284,
  250,280,250,280,246,270,246,270,250,260,250,260,
  240,240,240, };

int prot[17][MAXK] = {
  100,97,83,78,56,12,72,68,52,11,9,10,10,10,10,10,10,10,600,500,400,300,
  34,32,46,45,30,45,32,31,35,20,20,90,80,60,90,80,60,90,0,0,0,0,
  50,50,46,46,40,44,46,46,46,10,10,50,46,45,50,46,45,45,50,50,45,45,
  50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,
  30,30,25,25,30,25,10,10,10,0,0,10,15,20,10,15,20,20,10,10,10,10,
  35,40,24,23,40,20,10,10,10,0,0,10,15,20,10,15,20,20,10,10,10,10,
  5,8,27,27,50,27,5,5,5,0,0,5,10,15,5,10,15,15,5,5,5,5,
  10,10,10,10,5,10,10,10,10,5,5,10,10,15,10,10,15,15,10,10,10,10,
  25,25,20,20,20,20,5,5,5,0,0,10,15,20,10,15,20,20,10,10,10,10,
  25,25,20,20,20,20,5,5,5,0,0,10,15,20,10,15,20,20,10,10,10,10,
  10,10,10,10,10,10,10,10,10,0,0,10,10,10,10,10,10,10,10,10,10,10,
  10,10,7,7,5,2,10,9,10,2,2,10,10,10,10,10,10,10,5,5,5,5,
  120,120,100,100,0,0,0,0,0,0,0,150,200,250,150,200,250,250,0,0,0,0,
  250,240,200,190,180,100,210,200,180,90,90,100,100,150,100,100,150,
  150,1200,1100,1000,900,
  170,180,190,200,220,250,270,280,300,90,100,270,270,270,280,280,280,
  300,360,345,282,85,
  400,400,400,400,400,400,400,400,400,400,400,400,400,400,400,400,400,
  400,440,412,448,418,
  0,0,1,1,2,3,4,4,5,6,6,7,7,7,7,7,7,7,8,8,8,8, };

int algo[17][MAXK];
int alg[2][MAXK] = {
  140,150,160,170,190,230,240,250,270,400,410,240,240,240,250,250,250,270,
  160,208,225,406,
  84,84,84,84,84,84,84,84,84,64,64,84,84,84,84,84,84,84,76,56,57,57, };

char *kansyu[] = {"  ","","","","緿",
                  "","͢","Ҷ"," ", };

char *kanmei_p[] = {"硡","Ĺ","㡡","ī","-170","¼  ",
                    "  ","  ","  ζ","  ","  ","No.601","No.615",
                    "No.652","No.407","No.412","No.451","No.219",
		    "","","","Ȭ", };

char *kanmei_a[] = { "","ߥ꡼","ݡ","եå㡼",
                     "Ρ饹","PT-101",
		     "衼","ۡͥå","쥭ȥ",
                     "ѡ񡼥","󥿥å","VYC-51","VYB-53","VYF-55",
                     "VHC-32","VHB-34","VHF-36","VLB-17",
		     "٥󥹥ȥ","ݡȥޥ꡼","衼","ӥ󥷥ƥ",};

char *city[] = {"","Ի","","ǰ׹","Ω",};

int cityxy[9][2] = {
  72,18,93,13,115,13,194,13,120,65,173,109,173,105,143,113,46,106,};

char *tecd[] = {"Endurance Capacity Index (ѵ׻ؿ)",
                "Radius of Action (ưϰ)",
                "Efective for Range (Υ)",
                "Kill Probability (̿Ψ)",
                "ADC ","","Present Position (߰)", };

char *bun[] = {"","","","","","","","",
               "Ũ","ܶΥ","ޤ","","","й","Ψ",
               "ѵ׻ؿ","Ũμ","⼺ Bad Fight","Ũ",
               "ﳲ.","","Ƥ.",".","˲.",
               "  ȿˤ˲줿.","  ȿ⤵ޤ.","ι.","",
               "ˤ깶˲줿.","ι򤻤.","ȿ⤷ޤ.",
               "ܿ"," ޤ.", };

char *han[] = {"Serious... !",
               "You must be prepared for the worst. ǰи礻!",
               "You must Admit Defeat. ̤ǧ. The End.",
               "Reliable... Ǥ!",
               "Victory! ALGONS surrendered. 르Ϲ. The End",
               "Irresponsible selection. ̵Ǥ. End.",
               "See You Again!",};

char pro_t[] = " ... INPERIAL PROTONS NAVY ...";
char fcx[] = "<xfleet.dat> File not Open";
char lb_i[] = "<< Information >>";
char *kigou[] = {"B","D","S","G","A","E","U","F","H", };
int bokan[] = { 6,6,6,7,7,7,8,};
int nen[] = { 200,270,350,200,270,350,350, };
int nenryo[28];
int hikou[28];
int gnen[NEN];
int senko[NEN];
int flg_p[MAXK];
int flg_a[MAXK];
int tx[KOMA];
int ty[KOMA];
int ds[MAXK];
int es[MAXK];
int tr[9];
int tanka[8];
int sp;
int sa;
int frt;
int jb = 0;
int ja = 0;
int v = 0;
int pgy_sw;
int soku;
int houi;
int enmy;
int max;
int sum_p;
int sum_a;
unsigned long color[19];

/*:::::::::::::::::::::::::::::::::::::::::::::::::::::*/
main(argc, argv)
     int argc;
     char *argv[];
{
  int i, x, sw, lw, cw, end;
  char *lb = "Next";
  char *server;

  if (argc == 1)
    server = NULL;
  else
    server = argv[1];
  if ((disp = XOpenDisplay(server)) == NULL) {
    if (server == NULL)
      server = (char *)getenv("DISPLAY");
    fprintf(stderr, "Can't connect %s\n" ,server);
    exit(1);
  }

  ini();
  initx();

  do {
  Top:
    if (jb == 1)
      goto Han;
  Sec:
    if (ja == 1)
      goto Han;
    frt = 0;
    lw = loop_k();
    if (lw == ALL) {
      all();
      continue;
    }
    flg_p[sp] = 1;
  Srd:
    if (frt == 1)
      goto Han;
    if (jb == 1)
      goto Han;
    if (sp > 8 && sp < HIKO) {
      cl_k();
      m_yuso();
      new_p(0);
      next();
      continue;
    }
    sw = tec_dt();
    if (sw) {
      next();
      continue;
    }
    cw = loop_c();
    if (cw == TOP)
      goto Top;
    else if (cw == SRD)
      goto Srd;
    else if (cw == SEC)
      goto Sec;
  Han:
    jb = 0;
    x = kazo();
    if (x < KOMA) {
      algon(x);
      loop_m(lb);
      continue;
    }
    if (ja == 1) {
      for (i = 0; i < MAXK; i++)
	flg_p[i] = flg_a[i] = 0;
      ja = 0;
      end = judg();
      if (end == EXE)
	goto Sec;
    }
  } while(end != END);
  ending();
}
/*-----------------------------------------*/
loop_k()
{
  XEvent event;
  int sw;

  while (1) {
    XNextEvent(disp, &event);
    switch(event.type) {
    case Expose:
      itirann(&event);
      op_k();
      XWarpPointer(disp,None,wk,0,0,0,0,220,68);
      break;
    case LeaveNotify:
      itirann_a(&event);
      break;
    case EnterNotify:
      itirann_b(&event);
      break;
    case ButtonPress:
      sw = hit_but_k(&event);
      if (sw != EXE)
	return sw;
      break;
    }
  }
}

hit_but_k(eve)
     XButtonEvent *eve;
{
  int	i;
  char *lb1 = "Can Not Use.";
  char *lb2 = "All Stay.";

  if (eve->button == Button1) {
    for (i = 0; i < KOMA; i++) {
      if (eve->window == butto[i]){
	if (prot[KATI][i] < 0 || flg_p[i] == 1) {
	  loop_m(lb1);
	  return EXE;
	}
	else {
	  /*   cl_k();  */
	  sp = i;
	  return END;
	}
      }
    }
  }
  else if (eve->button == Button3) {
    loop_m(lb2);
    return ALL;
  }
  return 0;
}

itirann(eve)
     XExposeEvent *eve;
{
  int i;

  XSetForeground(disp,gc,color[0]);
  XmbDrawString(disp,wp,fs,gc,3,12,pro_t,strlen(pro_t));
  title();
  for (i = 0; i < KOMA; i++) {
    if(eve->window == butto[i]) {
      XSetWindowBackground(disp,butto[i],color[10]);
      XClearWindow(disp,butto[i]);
      if (prot[KATI][i] < 1)
	continue;
      sprintf(bf,"%8s %7s [%4d -%4d ]",kansyu[prot[SYU][i]],
	      kanmei_p[i], prot[X][i], prot[Y][i]);
      if (flg_p[i] == 1) {
	XSetForeground(disp,gc,color[8]);
      }
      else {
	XSetForeground(disp,gc,color[0]);
      }
      XmbDrawString(disp,butto[i],fs,gc,10,13,bf,strlen(bf));
      return;
    }
  }
}

itirann_a(eve)
     XCrossingEvent *eve;
{
  int i;

  for (i = 0; i < KOMA; i++) {
    if(eve->window == butto[i]) {
      if (prot[KATI][i] < 1)
	continue;
      if (flg_p[i] == 1)
	XSetForeground(disp,gc,color[8]);
      else {
	XSetForeground(disp,gc,color[0]);
	XSetWindowBackground(disp,butto[i],color[10]);
	XClearWindow(disp,butto[i]);
	sprintf(bf,"%8s %7s [%4d -%4d ]",kansyu[ prot[SYU][i] ],
		kanmei_p[i], prot[X][i], prot[Y][i]);
	XmbDrawString(disp,butto[i],fs,gc,10,13,bf,strlen(bf));
	return;
      }
    }
  }
}

itirann_b(eve)
     XCrossingEvent *eve;
{
  int i;

  XSetForeground(disp,gc,color[7]);
  for (i = 0;i < KOMA; i++) {
    if(eve->window == butto[i]) {
      if (prot[KATI][i] < 1)
	continue;
      if (flg_p[i] == 1)
	continue;
      else {
	XSetWindowBackground(disp,butto[i],color[16]);
	XClearWindow(disp,butto[i]);
	sprintf(bf,"%8s %7s [%4d -%4d ]",kansyu[ prot[SYU][i] ],
		kanmei_p[i], prot[X][i], prot[Y][i]);
	XmbDrawString(disp,butto[i],fs,gc,10,13,bf,strlen(bf));
	return;
      }
    }
  }
}

title()
{
  /*  char *ti1 = "ե꡼ ޥ "; */
  char *ti2 = "--- MAIN CONTROL CENTER ---";

  gxcls();
  /* XmbDrawString(disp,wind,fs,gc,30*8,12*16+14,ti1,strlen(ti1));
     XmbDrawString(disp,wind,fs,gc,26*8,12*16+14,pro_t,strlen(pro_t)); */
  XmbDrawString(disp,wind,fs,gc,26*8,12*16+14,ti2,strlen(ti2));
}

loop_c()
{
  XEvent event;
  int sw;

  sub_c();
  while (1) {
    XNextEvent(disp, &event);
    switch(event.type) {
    case Expose:
      select_c(&event);
      XWarpPointer(disp,None,wc,0,0,0,0,20,6);
      break;
    case EnterNotify:
      select_a(&event,REVERS);
      break;
    case LeaveNotify:
      select_a(&event,NORMAL);
      break;
    case ButtonPress:
      sw = (hit_but_c(&event));
      if (sw == EXE)
	break;
      else
	return sw;
      break;
    }
  }
}

hit_but_c(eve)
     XButtonEvent *eve;
{
  int i;

  if (eve->button == Button1) {
    for (i = 0; i < COMM; i++) {
      if (eve->window == comma[i]) {
	cl_k();
	cl_c();
	if (i == 0) {
	  movee();
	  return TOP;
	}
	else if (i == 1) {
	  flg_p[sp] = 0;
	  return TOP;
	}
	else if (i == 2) {
	  photo();
	  return SRD;
	}
	else if (i == 3) {
	  map();
	  return SRD;
	}
	else if (i == 4) {
	  frt = fight();
	  return SRD;
	}
	else if (i == 5) {
	  sub_c();
	  adc();
	  return EXE;
	}
	else if (i == 6) {
	  datadisp();
	  return SRD;
	}
	else if (i == 7) {
	  sv_ld();
	  return SRD;
	}
	else if (i == 8)
	  end_yn();  /* ending(); */
	return SRD;
      }
    }
  }
  return EXE;
}

select_c(eve)
     XExposeEvent *eve;
{
  int i;

  XSetForeground(disp,gc,color[0]);
  for (i = 0; i < COMM; i++) {
    if (eve->window == comma[i]) {
      XSetWindowBackground(disp,comma[i],color[11]);
      XClearWindow(disp,comma[i]);
      XmbDrawString(disp,comma[i],fs,gc,3,14,c_name[i],strlen(c_name[i]));
      return;
    }
  }
}

select_a(eve,mode)
     XCrossingEvent *eve;
     int mode;
{
  int i;
  GC agc;

  for (i = 0; i < COMM; i++) {
    if (eve->window == comma[i]) {
      if (mode == NORMAL) {
	XSetWindowBackground(disp,comma[i],color[11]);
	agc = gc;
      }
      else {
	XSetWindowBackground(disp,comma[i],color[16]);
	agc = rgc;
      }
      XClearWindow(disp,comma[i]);
      XmbDrawString(disp,comma[i],fs,agc,3,14,
		    c_name[i],strlen(c_name[i]));
      return;
    }
  }
}

all()
{
  int i;

  ja = 1;
  for (i = HIKO; i < KOMA; i++) {
    if (hikou[i-HIKO] > 0 && flg_p[i] == 0)
      hikou[i-HIKO]++;
  }
  if (flg_p[4] == 0) {
    if (senko[0] > 0)
      senko[0]++;
  }
}
/*---------------------------------------*/
initx()
{
  char **miss, *def;
  int	n_miss, i;

  if (setlocale(LC_ALL, "") == NULL) {
    fprintf(stderr,"Can't set the locale.\n");
    exit(1);
  }
  /*	disp = XOpenDisplay(NULL);  */

  if (XSupportsLocale() == False) {
    fprintf(stderr,"X dose not support the Locale.\n");
    exit(1);
  }
  color[0] = BlackPixel(disp, 0);
  color[1] = MyColor(disp, "blue");
  color[2] = MyColor(disp, "red");
  color[3] = MyColor(disp, "magenta");
  color[4] = MyColor(disp, "green");
  color[5] = MyColor(disp, "cyan");
  color[6] = MyColor(disp, "yellow");
  color[7] = WhitePixel(disp, 0);
  color[8] = MyColor(disp, "gray");
  color[9] = MyColor(disp, "LightSteelBlue");
  color[10] = MyColor(disp, "PaleGreen");
  color[11] = MyColor(disp, "tan");
  color[12] = MyColor(disp, "salmon");
  color[13] = MyColor(disp, "cornsilk");
  color[14] = MyColor(disp, "moccasin");
  color[15] = MyColor(disp, "plum");
  color[16] = MyColor(disp, "MidnightBlue");
  color[17] = MyColor(disp, "gold2");
  color[18] = MyColor(disp, "firebrick");

  wind = XCreateSimpleWindow(disp,DefaultRootWindow(disp),
			     0,0,640,400,2, color[0], color[9]);
  XStoreName(disp,wind,"FLEET COMMANDER X");
  XSelectInput(disp,wind, ExposureMask | ButtonPressMask);

  fs = XCreateFontSet(disp,"-*-*-medium-r-normal--14-*",
		      &miss, &n_miss, &def);
  if (n_miss > 0) {
    for(i = 0; i < n_miss; i++)
      fprintf(stderr,"Missing Charset: %s\n", miss[i]);
  }
  if (( fontst = XLoadQueryFont(disp, font_name )) == NULL) {
    fprintf(stderr,"Can not load Font [%s].\n", font_name);
    exit(1);
  }
  sub_s();
  sub_t();
  sub_r();
  sub_k();
  sub_f();
  XMapWindow(disp,wind);

  gc = XCreateGC(disp,wind, 0, 0);
  XSetForeground(disp, gc, color[0]);
  rgc = XCreateGC(disp,wind, 0, 0);
  XSetForeground(disp, rgc, color[7]);
  fgc = XCreateGC(disp,wind, 0, 0);
  XSetFont(disp,fgc,fontst->fid);
  XSetForeground(disp, fgc, color[0]);
  curs = XCreateFontCursor(disp,XC_sailboat);
  curs_m = XCreateFontCursor(disp,XC_watch);
  /*	XDefineCursor(disp,wc,curs);  */
  XDefineCursor(disp,wk,curs);
  XDefineCursor(disp,ws,curs);
  XDefineCursor(disp,wt,curs);
  XDefineCursor(disp,wf,curs);
  px = makepixmap(b_b,b_w,b_h);
  px_a = makepixmap(f_bship_bits,10,30);
  px_b = makepixmap(f_fship_bits,7,20);
  px_c = makepixmap(f_subm_bits,3,16);
  px_d = makepixmap(f_bort_bits,3,10);
  px_e = makepixmap(f_baship_bits,10,27);
  px_f = makepixmap(f_laship_bits,10,18);
  px_g = makepixmap(f_yship_bits,6,16);
  px_h = makepixmap(f_airp_bits,5,5);
  ax_a = makepixmap(a_bship_bits,10,30);
  ax_b = makepixmap(a_fship_bits,7,20);
  ax_c = makepixmap(a_subm_bits,3,16);
  ax_d = makepixmap(a_bort_bits,3,10);
  ax_e = makepixmap(a_baship_bits,10,27);
  ax_f = makepixmap(a_laship_bits,10,18);
  ax_g = makepixmap(a_yship_bits,6,16);
  ax_h = makepixmap(a_airp_bits,5,5);
}

makepixmap(char *data, unsigned int width, unsigned int height)
{
  Pixmap pid;

  pid = XCreateBitmapFromData(disp,wind,data,width,height);
  return pid;
}

sub_k()
{
  int i, x = 0, y = 0;

  wp = XCreateSimpleWindow(disp,wind,20*8,4,29*8,16,1,1,color[6]);
  wk = XCreateSimpleWindow(disp,wind,10,1*16+10,453,162,2,
			   BlackPixel(disp,DefaultScreen(disp)),
			   WhitePixel(disp,DefaultScreen(disp)));
  for ( i = 0; i < KOMA; i++) {
    if (i == KOMA / 2) {
      x = 226; y = 0;
    }
    butto[i] = XCreateSimpleWindow(disp,wk,x,y,225,16,1,
				   BlackPixel(disp,DefaultScreen(disp)),
				   color[10]);
    y += 18;
  }
  XSelectInput(disp,wk,ExposureMask);
  XSelectInput(disp,wp,ExposureMask);
  for (i = 0; i < KOMA; i++)
    XSelectInput(disp,butto[i],ExposureMask | ButtonPressMask |
		 EnterWindowMask | LeaveWindowMask);
  XMapSubwindows(disp,wk);
}

sub_c()
{
  int i, x = 0, y = 0;

  wc = XCreateSimpleWindow(disp,wind,5,10,76,17*COMM+1,2,1,0);
  for (i = 0; i < COMM; i++) {
    comma[i] = XCreateSimpleWindow(disp,wc,x,y,75,16,1,
				   BlackPixel(disp,DefaultScreen(disp)),
				   color[11]);
    y += 17;
  }
  XSelectInput(disp,wc,ExposureMask);
  for (i = 0; i < COMM; i++)
    XSelectInput(disp,comma[i],ExposureMask | ButtonPressMask |
		 EnterWindowMask | LeaveWindowMask);
  XMapSubwindows(disp,wc);
  XMapWindow(disp,wc);
}

op_k()
{
  XMapWindow(disp,wk);
  XMapWindow(disp,wp);
}

cl_k()
{
  XUnmapWindow(disp,wk);
  XUnmapWindow(disp,wp);
}

cl_c()
{
  XDestroyWindow(disp,wc);
  /*   XUnmapWindow(disp,wc);  */
}
/*------------------------------*/
ending()
{
  XFreeFontSet(disp,fs);
  XFreeFont(disp,fontst);
  XFreeGC(disp, gc);
  XFreeGC(disp, rgc);
  XFreeGC(disp, fgc);
  XFreePixmap(disp,px);
  XFreePixmap(disp,px_a);
  XFreePixmap(disp,px_b);
  XFreePixmap(disp,px_c);
  XFreePixmap(disp,px_d);
  XFreePixmap(disp,px_e);
  XFreePixmap(disp,px_f);
  XFreePixmap(disp,px_g);
  XFreePixmap(disp,px_h);
  XFreePixmap(disp,ax_a);
  XFreePixmap(disp,ax_b);
  XFreePixmap(disp,ax_c);
  XFreePixmap(disp,ax_d);
  XFreePixmap(disp,ax_e);
  XFreePixmap(disp,ax_f);
  XFreePixmap(disp,ax_g);
  XFreePixmap(disp,ax_h);
  XDestroyWindow(disp,wind);
  exit(1);
}

end_yn()
{
  XEvent e;
  char *lb[] = {"Yes Quit","No Return",};
  int sw;

  while(1) {
    XNextEvent(disp, &e);
    switch(e.type) {
    case Expose:
      draw_t(&e,lb);
      break;
    case EnterNotify:
      draw_ta(&e,lb,REVERS);
      break;
    case LeaveNotify:
      draw_ta(&e,lb,NORMAL);
      break;
    case ButtonPress:
      sw = hit_but_q(&e);
      if (sw == END)
	ending();
      else if (sw == EXE)
	return;
      break;
    }
  }
}

hit_but_q(eve)
     XButtonEvent *eve;
{
  int i;

  if (eve->button == Button1) {
    for (i = 0; i < TOG; i++) {
      if (eve->window == togl[i]) {
	cl_t();
	if (i == 0)
	  return END;
	else
	  return EXE;
      }
    }
  }
  return 0;
}
/*-----------------------------------------------*/
judg()
{
  int end, i, z, r = 0, x = 0, y = 0;
  int FULL = 6980, SCND = 5500, SARD = 3500;
  char *lb = "Total Value    Protect Ratio       Attack Effeciency";

  XUnmapSubwindows(disp,wind);
  gxcls();
  tr[5]++;
  for (i = 0; i < MAXK; i++) {
    x += algo[KATI][i];
    y += prot[KATI][i];
    if (i < 9 && prot[KATI][i] < 0)
      r++;
  }
  if (x != FULL) {
    z = (int)((100 - (double)(FULL - y) /
		(FULL - x) * 100.0 ) * sqrt(tr[5]/50+1));
  }
  else
    z = 0;
  x += sum_a;
  y += sum_p;
  sprintf(bf,"<<  JUDGMENT  >>  After     days");
  XmbDrawString(disp,wind,fs,gc,26*8,1*16+14,bf,strlen(bf));
  sprintf(bf,"%d",tr[5]);
  XDrawString(disp,wind,fgc,47*8,1*16+14,bf,strlen(bf));
  XmbDrawString(disp,wind,fs,gc,15*8,4*16+14,lb,strlen(lb));
  sprintf(bf,"IMPERIAL PROTON .....");
  XmbDrawString(disp,wind,fs,gc,3*8,6*16+14,bf,strlen(bf));
  sprintf(bf,"%3.0f%%             %d",(double)y / FULL * 100.0, z);
  XDrawString(disp,wind,fgc,35*8,6*16+14,bf,strlen(bf));
  sprintf(bf,"UNITED ALGONS .......");
  XmbDrawString(disp,wind,fs,gc,3*8,8*16+14,bf,strlen(bf));
  sprintf(bf,"%3.0f%%             ---",(double)x / FULL * 100.0);
  XDrawString(disp,wind,fgc,35*8,8*16+14,bf,strlen(bf));

  if (x > y && y >= SCND) {
    hantei(0);
    end = EXE;
  }
  else if (x > y && y < SCND && y > SARD) {
    hantei(1);
    end = EXE;
  }
  else if (x > y && y <= SARD || r == 9) {
    hantei(2);
    end = END;
  }
  else if (x < y && x > SARD) {
    hantei(3);
    end = END;
  }
  else if (x < y && x <= SARD) {
    hantei(4);
    end = END;
  }
  return( conti(end) );
}

conti(int end)
{
  XEvent e;
  int	i;
  char *lb[] = { "Continue","Quit",};

  while (1) {
    XNextEvent(disp, &e);
    switch(e.type) {
    case Expose:
      draw_t(&e,lb);
      break;
    case EnterNotify:
      draw_ta(&e,lb,REVERS);
      break;
    case LeaveNotify:
      draw_ta(&e,lb,NORMAL);
      break;
    case ButtonPress:
      if (e.xbutton.button == Button1) {
	for (i = 0; i < TOG; i++) {
	  if (e.xbutton.window == togl[i]) {
	    cl_t();
	    if (i == 1) {
	      if (end == EXE)
		hantei(5);
	      else
		hantei(6);
	      return END;
	    }
	    else
	      return EXE;
	  }
	}
      }
      break;
    }
  }
}

hantei(int n)
{
  loop_i(han[n]);
}

info()
{
  char *lb = "[[ INFORMATION ]]";

  XmbDrawString(disp,wind,fs,gc,15*8,15*16+14,lb,strlen(lb));
}
/*-----------------------------------------------------------------*/
photo()
{
  int i, a, b;

  gbcls();
  XSetFillStyle(disp,gc,FillStippled);
  XSetStipple(disp,gc,px);
  XSetForeground(disp,gc,color[0]);
  XFillRectangle(disp,wind,gc,10*4,5*4,580,360);
  a = prot[X][sp];
  b = prot[Y][sp];
  sprintf(bf,"-77 <-%4d -> +77     Position[%4d -%4d ]",a, a, b);
  XSetFillStyle(disp,gc,FillSolid);
  XSetForeground(disp,gc,color[7]);
  XmbDrawString(disp,wind,fs,gc,34*8,14,bf,strlen(bf));
  for( i = 0; i < 24; i += 2) {
    sprintf(bf,"%d",4 * i + prot[Y][sp] - 44);
    XmbDrawString(disp,wind,fs,gc,4,i*16+32,bf,strlen(bf));
  }
  tosi(a, b);
  if (a < 148 && b > 125 && b < 375 && a > 362 && b > 135 && b < 365)
    goto ds;
  else if (b < 136)
    dispoka(30, rikuN , a , b);
  else if (a < 363 && a > 147 && b > 185 && b < 325)
    dispoka(25, sima , a , b);
  else if (b > 364)
    dispoka(40, rikuS , a , b);
 ds:
  dispship(a ,b);
  XSetForeground(disp,gc,color[1]);
  XDrawRectangle(disp,wind,gc,10*4,5*4,580,360);
  loop_r();
}

loop_r()
{
  XEvent e;
  char *lb = "Return ?";

  XSetForeground(disp,gc,color[7]);
  while (1) {
    XNextEvent(disp, &e);
    switch(e.type) {
    case Expose:
      op_r();
      XmbDrawString(disp,wr,fs,gc,2,14,lb,strlen(lb));
      break;
    case ButtonPress:
      if (e.xbutton.button == Button3) {
	cl_r();
	return;
      }
      break;
    }
  }
}
/*----*/
dispoka(int n, unsigned xy[][2], int a, int b )
{
  int i, x, y, x1, y1;

  for ( i = 0; i < n ; i++ ) {
    x = fnx( xy[i][0], a );
    y = fny( xy[i][1], b );
    if ( i == 0 )
      continue;
    x1 = fnx( xy[i-1][0], a );
    y1 = fny( xy[i-1][1], b );
    if ( x > 155 ) x = 155;
    if ( x < 10  ) x = 10;
    if ( x1 > 155) x1 = 155;
    if ( x1 < 10 ) x1 = 10;
    if ( y > 95  ) y = 95;
    if ( y < 5   ) y = 5;
    if ( y1 > 95 ) y1 = 95;
    if ( y1 < 5  ) y1 = 5;
    if ( x != x1 && y != y1 )
      continue;
    XSetForeground(disp,gc,color[4]);
    XDrawLine(disp,wind,gc,x1*4,y1*4,x*4,y*4);
  }
}
/*------------------*/
dispship(int a, int b)
{
  int i, j, x, y, c, h, n;
  Pixmap pix_m;

  j = 1;
  for (i = 0; i < MAXK; i++) {
    x = fnx( prot[X][i], a);
    y = fny( prot[Y][i], b);
    c = 5;
    if (prot[KATI][i] < 0)
      continue;
    if ( x < 10 || x > 152 || y < 5 || y > 92 )
      continue;
    if (i < 2) {
      pix_m = px_a;h = 10;n = 30;
    } else if (i > 1 && i < 4) {
      pix_m = px_b;
      h = 7;
      n = 20;
    } else if (i == 4 && j == 2 &&
	       (sp > 4 || sp < 2) && senko[2] > 0)
      continue;
    else if (i == 4) {
      pix_m = px_c;
      h = 3;
      n = 16;
    } else if (i == 5) {
      pix_m = px_d;
      h = 3;
      n = 10;
    } else if (i > 5 && i < 8) {
      pix_m = px_e;
      h = 10;
      n = 27;
    } else if (i == 8) {
      pix_m = px_f;
      h = 10;
      n = 18;
    } else if (i > 8 && i < 11) {
      pix_m = px_g;
      h = 6;
      n = 16;
    } else if (i > 10 && i < KOMA) {
      airplan(i, j, x, y, a, b);
      continue;
    } else if (i > 17) {
      h = 15;
      n = 15;
      c = 6;
    }

    XSetForeground(disp,gc,color[c]);
    if (i > 17)
      XFillRectangle(disp,wind,gc,x*4,y*4,h,n);
    else
      XCopyPlane(disp,pix_m,wind,gc,0,0,h,n,x*4,y*4,1);
  }
  j = 2;
  for (i = 0; i < MAXK; i++) {
    x = fnx(algo[X][i],a);
    y = fny(algo[Y][i],b);
    c = 3;
    if (algo[KATI][i] < 0)
      continue;
    if ( x < 10 || x > 152 || y < 5 || y > 92)
      continue;
    if (i < 2) {
      pix_m = ax_a;h = 10;n = 30;
    } else if (i > 1 && i < 4) {
      pix_m = ax_b;h = 7;n = 20;
    } else if (i == 4 && j == 2 &&
	     (sp > 4 || sp < 2) && senko[2] > 0)
      continue;
    else if (i == 4) {
      pix_m = ax_c;h = 3;n = 16;
    } else if (i == 5) {
      pix_m = ax_d;h = 3;n = 10;
    } else if (i > 5 && i < 8) {
      pix_m = ax_e;h = 10;n = 27;
    } else if (i == 8) {
      pix_m = ax_f;h = 10;n = 18;
    } else if (i > 8 && i < 11) {
      pix_m = ax_g;h = 6;n = 16;
    } else if (i > 10 && i < KOMA) {
      airplan(i, j, x, y, a, b);
      continue;
    } else if (i > 17) {
      h = 15;n = 15;c = 6;
    }

    XSetForeground(disp,gc,color[c]);
    if (i > 17)
      XFillRectangle(disp,wind,gc,x*4,y*4,h,n);
    else
      XCopyPlane(disp,pix_m,wind,gc,0,0,h,n,x*4,y*4,1);
  }
}

airplan(int n, int sw, int x, int y, int a, int b)
{
  int key;

  if (sw == 1)
    key = HIKO;
  else
    key = -3;
  if (hikou[n-key] == 0) {
    planp(sw, a, b, n);
  }
  else
    plan(x, y, sw, n);
}

planp(int sw, int a, int b, int n)
{
  int x, y, bo, rr, col;

  bo = bokan[n-HIKO];
  rr = (fmod(n+1, 3) + 1) * 2 -1;
  if (sw == 1) {
    x = (int)fnx(prot[X][bo], a);
    y = (int)fny(prot[Y][bo], b);
  }
  else {
    x = (int)fnx(algo[X][bo], a);
    y = (int)fny(algo[Y][bo], b);
  }
  if (x+1 < 2 || x+1 > 157 || y+rr < 2 || y+rr > 98)
    return;
  col = get_col(sw);
  XSetForeground(disp,gc,color[col]);
  if (sw == 1)
    XCopyPlane(disp,px_h,wind,gc,0,0,5,5,x*4+2,(y+rr)*4,1);
  else
    XCopyPlane(disp,ax_h,wind,gc,0,0,5,5,x*4+3,(y+rr)*4,1);
}

plan(int x, int y, int sw, int n)
{
  int col;

  if (n == sp && sw == 1)
    col = 6;
  else if (sw != 1)
    col = 3;
  else
    col = 5;
  XSetForeground(disp,gc,color[col]);
  if (sw == 1)
    XCopyPlane(disp,px_h,wind,gc,0,0,5,5,x*4,y*4,1);
  else
    XCopyPlane(disp,ax_h,wind,gc,0,0,5,5,x*4,y*4,1);
}

get_col(int sw )
{
  if (sw == 1)
    return 5;
  else
    return 3;
}

tosi(int x, int y)
{
  int i, xc, yc;

  for(i = 0; i < 9; i++) {
    xc = cityxy[i][0] - (x - 82)/2;
    yc = cityxy[i][1] - (y - 50)/4;

    if (xc < 2 || yc < 2 || xc > 69 || yc > 22)
      continue;
    dispcity(i, xc, yc);
  }
}

dispcity(int n, int x, int y)
{
  char *lb1 = "⥢";

  XSetForeground(disp,gc,color[7]);
  if (n < 4) {
    sprintf(bf,"%s %s",city[n], kanmei_a[n+KOMA]);
    XmbDrawString(disp,wind,fs,gc,x*8,y*16,bf,strlen(bf));
  }
  else if (n > 4) {
    sprintf(bf,"%s %s",city[n-5], kanmei_p[n+13]);
    XmbDrawString(disp,wind,fs,gc,x*8,y*16,bf,strlen(bf));
  }
  else {
    sprintf(bf,"%s %s",city[4], lb1);
    XmbDrawString(disp,wind,fs,gc,x*8,y*16,bf,strlen(bf));
  }
}
/*------------------------------------------------------*/
map()
{
  int i;
  char *lb1 = "200--+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+";
  char *lb2 = "40    80   120   160   200   240   280   320   360   400   440";

  gxcls();
  XSetForeground(disp,gc,color[0]);
  XDrawRectangle(disp,wind,gc,0,0,500,399);
  for (i = 0; i < 25; i++) {
    if (i == 5 || i == 15 || i == 20) {
      itoa(i*20);
      XmbDrawString(disp,wind,fs,gc,4,i*16,buff,strlen(buff));
    }
  }
  XmbDrawString(disp,wind,fs,gc,2,160,lb1,strlen(lb1));
  XmbDrawString(disp,wind,fs,gc,34,144,lb2,strlen(lb2));

  XSetForeground(disp,gc,color[0]);
  maping(rikuN, 30);
  maping(rikuS, 40);
  maping(sima,  25);
  XSetForeground(disp,gc,color[1]);
  for (i = 0; i < 22; i++) {
    if (prot[KATI][i] > 0)
      XFillArc(disp,wind,gc,prot[14][i],prot[15][i]*4/5,
	       4,4,0,360*64);
  }
  loop_r();
}

maping(unsigned xy[][2],int n)
{
  int i;

  for (i = 0; i < n-1; i++)
    XDrawLine(disp,wind,gc,
	      xy[i][0],xy[i][1]*4/5,xy[i+1][0],xy[i+1][1]*4/5);
}
/*----------------------------------------------------*/
movee()
{
  int x0, y0, yn, sw;
  int x, y;

  jb = 1;
  soku = 0;
  if (sp > 10 && sp < KOMA)
    sw = m_air();
  else if (sp == 5)
    sw = m_gyo();
  while (sw != 3) {
    if (loop_s() == QUI) {
      flg_p[sp] = 0;
      jb = 0;
      return;
    }

    if (sp == 4)
      m_sen();

    x = (int)fnb( prot[X][sp], soku, houi );
    y = (int)fnc( prot[Y][sp], soku, houi );
    prot[X][sp] = x;
    prot[Y][sp] = y;
    x0 = houi;
    y0 = soku;
    yn = hani(x, y);
    sw = xycheck(yn, x0, y0);
    if (sw == 1)
      return;
  }
  new_p(soku);
  next();
}

new_p(int sk)
{
  int i;
  double aa;
  char *lb4 = "Բǽ.";

  lwcls();
  sprintf(bf,"===== New Position ===== [%4d -%4d ]",
	  prot[X][sp], prot[Y][sp]);
  XSetForeground(disp,gc,color[0]);
  XmbDrawString(disp,wind,fs,gc,5*8,22*16+14,bf,strlen(bf));

  if (sp < 9 && sp > 5) {
    for (i = HIKO; i < KOMA; i++) {
      if ( hikou[i-HIKO] == 0 && bokan[i-HIKO] == sp ) {
	prot[X][i] = prot[X][sp];
	prot[Y][i] = prot[Y][sp];
      }
    }
  }
  else if (sp > 10) {
    aa = fna(prot[X][sp], prot[Y][sp],
	     prot[X][bokan[sp-HIKO]], prot[Y][bokan[sp-HIKO]]);
    if (aa > (nenryo[sp-NEN] + (hikou[sp-NEN] - hikou[sp-HIKO]) *
	      prot[KOU][ bokan[sp-HIKO]])) {
      loop_m(lb4);
    }
    if (v == 0)
      nenryo[sp-NEN] -= sk;
    else
      v = 0;
    a_metr();
  }
  else if (sp == 5) {
    if (v == 0)
      gnen[0] -= sk;
    else
      v = 0;
    g_metr();
  }
}

next()
{
  XEvent e;
  char *lb[] = {"Next","Photo",};

  while (1) {
    XNextEvent(disp, &e);
    switch(e.type) {
    case Expose:
      draw_t(&e,lb);
      break;
    case EnterNotify:
      draw_ta(&e,lb,REVERS);
      break;
    case LeaveNotify:
      draw_ta(&e,lb,NORMAL);
      break;
    case ButtonPress:
      if (hit_key_n(&e) == END) {
	return;
      }
      break;
    }
  }
}

hit_key_n(eve)
     XButtonEvent *eve;
{
  int i;

  if (eve->button == Button1) {
    for(i = 0; i < TOG; i++) {
      if (eve->window == togl[i]) {
	cl_t();
	if (i == 0) {
	  return END;
	}
	else if (i == 1 && prot[KATI][sp] > -1) {
	  photo();
	  return END;
	}
      }
    }
  }
  return EXE;
}

int hani(int x, int y)
{
  if ( x > 226 && x < 284 && y < 280 && y > 240 )
    return 1;
  if ( x < 0 || x > 480 || y < 0 || y > 500 )
    return 2;
  if ( ( x > 70 && x < 180 && y < 80 ) ||
       ( x > 180 && x < 290 && y < 60 ) ||
       ( x > 290 && x < 310 && y < 90 ) ||
       ( x > 310 && x < 408 && y < 60 ) ||
       ( x > 410 && x < 450 && y < 40 ) )
    return 3;
  if ( ( x > 70 && x < 90 && y > 420 ) ||
       ( x > 180 && x < 210 && y > 440 ) ||
       ( x > 210 && x < 310 && y > 450 ) ||
       ( x > 310 && x < 380 && y > 410 ) ||
       ( x > 380 && x < 450 && y > 420 ) ||
       ( x > 90  && x < 160 && y > 440 ) ||
       ( x > 160 && x < 180 && y > 420 ) ||
       ( x < 0 ) || ( x > 480 ) || ( y < 0 ) || ( y > 500 ) )
    return 4;
  return 0;
}

xycheck(int yn, int x0, int y0)
{
  int i;

  if (sp > 10) {
    if (yn == 2) {
      badp(x0, y0);
      return 0;
    }
    return 3;
  }
  if ( yn == 2 || yn == 4 ) {
    badp(x0, y0);
    return 0;
  }
  if (yn == 1 || yn == 3) {
    if ( sp < 9 && sp > 5 ) {
      for (i = HIKO; i < KOMA; i++) {
	if ( hikou[i-HIKO] == 0 && sp == bokan[i-HIKO] )
	  prot[KATI][i] = -1;
      }
    }
    gxcls();
    sprintf(bf,"%s %s %s %s",bun[31], kansyu[prot[SYU][sp]],
	    kanmei_p[sp], bun[32] );
    XmbDrawString(disp,wind,fs,gc,30*8,21*16+14,bf,strlen(bf));
    prot[KATI][sp] = -1;
    loop_r();
    return 1;
  }
  else
    return 3;
}

badp( int x0, int y0)
{
  char *lb = "Bad Position Enter.";

  loop_m(lb);
  prot[X][sp] = (int)fnb( prot[X][sp], y0, x0+180);
  prot[Y][sp] = (int)fnc( prot[Y][sp], y0, x0+180);
  loop_r();
}

m_air()
{
  XEvent e;
  int sw;
  char *lb[] = {"Back to Ship","Flaying",};

  while (1) {
    XNextEvent(disp, &e);
    switch(e.type) {
    case Expose:
      draw_t(&e,lb);
      break;
    case EnterNotify:
      draw_ta(&e,lb,REVERS);
      break;
    case LeaveNotify:
      draw_ta(&e,lb,NORMAL);
      break;
    case ButtonPress:
      sw = hit_key_a(&e);
      if (sw != 0) {
	cl_t();
	return sw;
      }
      gxcls();
      break;
    }
  }
}

hit_key_a(eve)
     XButtonEvent *eve;
{
  int i, sw;

  if (eve->button == Button1) {
    for(i = 0; i < TOG; i++) {
      if (eve->window == togl[i]) {
	sw = a_inp(i+1);
	return sw;
      }
    }
  }
}

a_inp(int sw)
{
  int fu;
  double aa;
  char *lb1 = "Suicidal Accident..";
  char *lb2 = "Settled Back.";
  char *lb3 = "Can not Back.";
  char *lb4 = "Accident! Can not Flight.";

  if ( prot[KOU][sp] > nenryo[sp-NEN] )
    fu = nenryo[sp-NEN];
  else
    fu = prot[KOU][sp];

  aa = fna( prot[X][sp], prot[Y][sp],
	    prot[X][bokan[sp-HIKO]], prot[Y][bokan[sp-HIKO]] );
  if ( aa > fu && hikou[sp-HIKO] == hikou[sp-NEN] ) {
      prot[KATI][sp] = -1;
      loop_m(lb1);
      return 3;
    }
  if (sw == 1) {
    if ( hikou[sp-HIKO] == 0 ) {
      loop_m(lb2);
      return 0;
    }
    if ( prot[KATI][bokan[sp-HIKO]] < 0 ||
	 (int)fna( prot[X][sp], prot[Y][sp], prot[X][bokan[sp-HIKO]],
		   prot[Y][bokan[sp-HIKO]] ) > fu ) {
      loop_m(lb3);
      return 0;
    }
    if ( hikou[sp-HIKO] > 0 ) {
      prot[X][sp] = prot[X][ bokan[sp-HIKO] ];
      prot[Y][sp] = prot[Y][ bokan[sp-HIKO] ];
      nenryo[sp-NEN] = nenryo[sp-HIKO];
      v = 1;
      hikou[sp - HIKO] = 0;
      if (prot[TAI][sp] < 10) {
	prot[TAI][sp] = 8;
	prot[MEI][sp] = 40;
      }
      return 3;
    }
  }
  else if ( hikou[sp-HIKO] == hikou[sp-NEN] ) {
    loop_m(lb4);
    return 3;
  }
  hikou[sp-HIKO]++;
  return 2;
}

m_gyo()
{
  XEvent e;
  int sw;
  char *lb1 = "Out of Fuel.Drifting.";
  char *lb[] = {"Oil Suply","Move",};

  if (gnen[0] == 0) {
    loop_m(lb1);
    return 1;
  }
  while (1) {
    XNextEvent(disp,&e);
    switch(e.type) {
    case Expose:
      draw_t(&e,lb);
      break;
    case EnterNotify:
      draw_ta(&e,lb,REVERS);
      break;
    case LeaveNotify:
      draw_ta(&e,lb,NORMAL);
      break;
    case ButtonPress:
      sw = hit_key_g(&e);
      if (sw != 0) {
	cl_t();
	return sw;
      }
      break;
    }
  }
  return sw;
}

hit_key_g(eve)
     XButtonEvent *eve;
{
  int i, sw;

  if (eve->button == Button1) {
    for(i = 0; i < TOG; i++) {
      if (eve->window == togl[i]) {
	sw = g_inp(i);
	return sw;
      }
    }
  }
}

g_inp(int in)
{
  int x ,y, GYO = 5, mx = 282, my = 448, nx = 85, ny = 418;
  char *lb = "Can Not Supply.";

  x = prot[X][GYO];
  y = prot[Y][GYO];
  if (in == 0) {
    if ( (int)fna(x, y, mx, my) < prot[KOU][GYO] && prot[KATI][20] > 0 )
      {
	prot[X][GYO] = mx;
	prot[Y][GYO] = my;
	gnen[0] = gnen[1];
	v = 1;
	return 3;
      }
    else if ( ((int)fna(x, y, nx, ny) < prot[KOU][GYO])
	      && ( prot[KATI][21] > 0 ) ) {
      prot[X][GYO] = nx;
      prot[Y][GYO] = ny;
      gnen[0] = gnen[1];
      v = 1;
      return 3;
    }
    else {
      loop_m(lb);
      return 0;
    }
  }
  return 2;
}

m_sen()
{
  XEvent e;
  char *lb[] = {"","",};

  while (1) {
    XNextEvent(disp, &e);
    switch(e.type) {
    case Expose:
      draw_t(&e,lb);
      break;
    case EnterNotify:
      draw_ta(&e,lb,REVERS);
      break;
    case LeaveNotify:
      draw_ta(&e,lb,NORMAL);
      break;
    case ButtonPress:
      if (hit_key_s(&e) != 0) {
	cl_t();
	return;
      }
      break;
    }
  }
}

hit_key_s(eve)
     XButtonEvent *eve;
{
  int i;
  char *lb = "Ի֤Ĺ᤮ޤ.";

  if (eve->button == Button1) {
    for (i = 0; i < TOG; i++) {
      if (eve->window == togl[i]) {
	if (i == 0) {
	  senko[0] = 0;
	  return 2;
	}
	if (i == 1) {
	  if (senko[0] == senko[1]) {
	    loop_m(lb);
	    return 0;
	  }
	  else {
	    senko[0]++;
	    return 2;
	  }
	}
      }
    }
  }
}

m_yuso()
{
  int x, y, z, mx = 85, my = 418, nx = 1, ny = 360;
  char *lb2 = "˲ƱԲǽ.";
  char *lb3 = "ưԥƥư.";
  char *lb4 = "[ Automatic Navigation System ] Now Running.";
  char *lb5 = "This is Controled by.";

  gxcls();
  sprintf(bf,"Position [ %d - %d ]", prot[X][sp], prot[Y][sp]);
  XmbDrawString(disp,wind,fs,gc,33*8,21*16*14,bf,strlen(bf));
  jb = 1;
  if (prot[KATI][21] < 0) {
    loop_m(lb2);
    return 1;
  }
  XmbDrawString(disp,wind,fs,gc,20*8,14*16+14,lb3,strlen(lb3));
  x = prot[X][sp];
  y = prot[Y][sp];
  if (x == nx && y == ny) {
    tx[sp] = mx;
    ty[sp] = my;
    tanka[sp-9] = 1;
  }
  if (tanka[sp-9] != 1) {
    tx[sp] = nx;
    ty[sp] = ny;
  }
  if (x == mx && y == my) {
    tx[sp] = nx;
    ty[sp] = ny;
    tanka[sp-9] = 0;
  }
  z = (int)fna(x, y, tx[sp], ty[sp]);
  if (z == 0)
    return 2;
  if (z > prot[KOU][sp])
    z = prot[KOU][sp];
  prot[X][sp] = fnr(x, y, tx[sp], ty[sp], z);
  prot[Y][sp] = fns(x, y, tx[sp], ty[sp], z);
  XmbDrawString(disp,wind,fs,gc,25*8,15*16+14,lb4,strlen(lb4));
  XmbDrawString(disp,wind,fs,gc,25*8,16*16+14,lb5,strlen(lb5));
  if (x == mx && y == my) {
    sprintf(bf,"Transported %d",YUSO );
    XmbDrawString(disp,wind,fs,gc,29*8,17*16+14,bf,strlen(bf));
    sum_p += YUSO;
    XBell(disp,-80);
  }
  return 2;
}
/*------------------------------*/
tec_dt()
{
  char *lb1 = "Over Time.ޤ.";
  char *lb3 = "";
  char *lb4 = "Over Time Accident.";

  gxcls();
  XSetForeground(disp,gc,color[0]);
  if (sp > 10 && sp < KOMA) {
    if (hikou[sp-HIKO] > hikou[sp-NEN]) {
      prot[KATI][sp] = -1;
      loop_m(lb1);
      return 1;
    }
    a_metr();
  }
  if (sp == 5)
    g_metr();
  dat();

  if (sp == 4) {
    if (senko[0] != 0) {
      sprintf(bf," Time = %d / %d", senko[0], senko[1]);
      XmbDrawString(disp,wind,fs,gc,55*8,15*16+14,bf,strlen(bf));
    }
    else {
      XmbDrawString(disp,wind,fs,gc,59*8,15*16+14,lb3,strlen(lb3));
    }
    if (senko[0] > senko[1]) {
      loop_m(lb4);
      prot[KATI][4] = -1;
      return 1;
    }
  }
  return 0;
}

dat()
{
  int i, y;
  char *lb = " ........";

  sprintf(bf,"No.%2d %8s %8s", sp+1,
	  kansyu[prot[SYU][sp] ],kanmei_p[sp] );
  XmbDrawString(disp,wind,fs,gc,15*8,14*16+14,bf,strlen(bf));
  sprintf(bf,"%s ........ [%4d -%4d ]",
	  tecd[6], prot[X][sp], prot[Y][sp]);
  XmbDrawString(disp,wind,fs,gc,2,15*16+14,bf,strlen(bf));
  y = 16;
  for ( i = 0; i < 4; i++) {
    XmbDrawString(disp,wind,fs,gc,2,(y+i)*16+14,
		  tecd[i],strlen(tecd[i]));
    XmbDrawString(disp,wind,fs,gc,30*8,(y+i)*16+14,lb,strlen(lb));
    itoa(prot[i][sp]);
    XmbDrawString(disp,wind,fs,gc,38*8,(y+i)*16+14,buff,strlen(buff));
  }
}
/*--------------------------------------------*/
a_metr()
{
  char *lb1 = "::::::::::  Flying  ::::::::::";
  char *lb2 = ":::::::::::::::::::::::::::::::::::\
   Not Flying  ::::::::::::::::::::::::::::::";

  metr(AIRP);
  sprintf(bf,"Time %d / %d", hikou[sp-HIKO], hikou[sp-NEN] );
  XmbDrawString(disp,wind,fs,gc,62*8,3*16+14,bf,strlen(bf));
  sprintf(bf,"< %s %s >",kansyu[prot[SYU][ bokan[sp-HIKO] ]],
	  kanmei_p[ bokan[sp-HIKO]] );
  XmbDrawString(disp,wind,fs,gc,60*8,1*16+14,bf,strlen(bf));
  if (hikou[sp-HIKO] != 0 ) {
    if (prot[KATI][ bokan[sp-HIKO]] > 0) {
      sprintf(bf,"%s Distans to %s is %d",lb1,
	      kanmei_p[ bokan[sp-HIKO]],
	      fna( prot[X][sp],prot[Y][sp],
		   prot[X][bokan[sp-HIKO]],
		   prot[Y][bokan[sp-HIKO]] ) + 1);
    }
    XmbDrawString(disp,wind,fs,gc,6*8,21*16+14,bf,strlen(bf));
  }
  else
    XmbDrawString(disp,wind,fs,gc,1*8,21*16+14,lb2,strlen(lb2));
}

g_metr()
{
  metr(GYRY);
  sprintf(bf,"Distans to %s %d - to %s %d",
	  city[2],
	  fna( prot[X][sp],prot[Y][sp],prot[X][20],prot[Y][20] ),
	  city[3],
	  fna( prot[X][sp],prot[Y][sp],prot[X][21],prot[Y][21] ));
  XmbDrawString(disp,wind,fs,gc,40*8,22*16+14,bf,strlen(bf));
}

metr(int sw)
{
  int fu, ma ,m;
  char *lb1 = "[ Fuel Meter ]";

  gxcls();
  if (sw == AIRP) {
    fu = nenryo[sp-NEN];
    ma = nenryo[sp-HIKO];
  }
  else if (sw == GYRY) {
    fu = gnen[0];
    ma = gnen[1];
  }

  m = 76 - (double)fu / ma * 48;
  sprintf(bf,"<- %3.0f%%",(double)fu / ma * 100 );
  XmbDrawString(disp,wind,fs,gc,71*8,16*(m/4-1)+14,bf,strlen(bf));
  sprintf(bf,"< %d >", fu);
  XmbDrawString(disp,wind,fs,gc,71*8,16*m/4+14,bf,strlen(bf));
  sprintf(bf,"Full Tank ( %d )", ma );
  XmbDrawString(disp,wind,fs,gc,62*8,2*16+14,bf,strlen(bf));

  XDrawRectangle(disp,wind,gc,128*4,28*4,40,192);
  XmbDrawString(disp,wind,fs,gc,62*8,5*16+14,lb1,strlen(lb1));
  XmbDrawString(disp,wind,fs,gc,62*8,7*16+14,"F",1);
  XmbDrawString(disp,wind,fs,gc,62*8,19*16+14,"E",1);

  XFillRectangle(disp,wind,gc,128*4+1,m*4+1,38,305-(m*4+1));
}
/*----------------------------*/
fna(int a, int b, int c, int d)
{
  return (sqrt(pow((a-c), 2)+pow((b-d), 2)));
}

fnr(int x, int y, int a, int b, int c)
{
  return ((a-x)*c/
	  floor(sqrt(pow(x-a, 2)+pow(y-b, 2)))+x);
}

fns(int x, int y, int a, int b, int c)
{
  return ((b-y)*c/
	  floor(sqrt(pow(x-a, 2)+pow(y-b, 2)))+y);
}
/*----------------------------------------------*/
adc()
{
  int i;

  gxcls();
  for (i = 0; i < 9; i++) {
    sprintf(bf,"A.%s %s %8s %s %4d Power", kigou[i],
	    tecd[4], kansyu[i], tecd[5], prot[i+4][sp] );
    XmbDrawString(disp,wind,fs,gc,1,(14+i)*16+14,bf,strlen(bf));
  }
}
/*---------------------------------------*/
gxcls()
{
  XSetForeground(disp,gc,color[0]);
  XSetWindowBackground(disp,wind,color[9]);
  XClearWindow(disp,wind);
}

gbcls()
{
  XSetForeground(disp,gc,color[7]);
  XSetWindowBackground(disp,wind,color[16]);
  XClearWindow(disp,wind);
}

lwcls()
{
  XClearArea(disp,wind,0,22*16,640,1*16,False);
}
/*---------------------------------------------*/
sv_ld()
{
  XEvent e;
  char *lb[] = {"Save","Load",};

  while(1) {
    XNextEvent(disp, &e);
    switch(e.type) {
    case Expose:
      draw_t(&e,lb);
      break;
    case EnterNotify:
      draw_ta(&e,lb,REVERS);
      break;
    case LeaveNotify:
      draw_ta(&e,lb,NORMAL);
      break;
    case ButtonPress:
      if (hitb_sv(&e) == EXE)
	return;
      break;
    }
  }
}

hitb_sv(eve)
     XButtonEvent *eve;
{
  int i;

  if (eve->button == Button1) {
    for (i = 0; i < TOG; i++) {
      if (eve->window == togl[i]) {
	cl_t();
	if (i == 0) {
	  saved();
	  cont();
	  return EXE;
	}
	else {
	  loadd();
	  return EXE;
	}
      }
    }
  }
  else if (eve->button == Button3) {
    cl_t();
    return EXE;
  }
}

cont()
{
  XEvent e;
  int sw;
  char *lb[] = {"Continue","Exit",};

  while(1) {
    XNextEvent(disp, &e);
    switch(e.type) {
    case Expose:
      draw_t(&e,lb);
      break;
    case EnterNotify:
      draw_ta(&e,lb,REVERS);
      break;
    case LeaveNotify:
      draw_ta(&e,lb,NORMAL);
      break;
    case ButtonPress:
      sw = hitb_co(&e);
      if (sw == END)
	ending();
      else if (sw == EXE)
	return;
      break;
    }
  }
}

hitb_co(eve)
     XButtonEvent *eve;
{
  int i;

  if (eve->button == Button1) {
    for (i = 0; i < TOG; i++) {
      if (eve->window == togl[i] ) {
	cl_t();
	if (i == 0)
	  return EXE;
	else
	  return END;
      }
    }
  }
}

saved()
{
  FILE *fp;
  char *lb = "Saved Data O.K.";

  if ( ( fp = fopen("xfleet.dat", "wb") ) == NULL ) {
    fprintf(stderr,"%s\n",fcx);
    exit(1);
  }
  fwrite( algo,  sizeof(algo),  1, fp);
  fwrite( prot,  sizeof(prot),  1, fp);
  fwrite( hikou, sizeof(hikou), 1, fp);
  fwrite( nenryo,sizeof(nenryo),1, fp);
  fwrite( gnen,  sizeof(gnen),  1, fp);
  fwrite( senko, sizeof(senko), 1, fp);
  fwrite( flg_p,  sizeof(flg_p),  1, fp);
  fwrite( flg_a,  sizeof(flg_a),  1, fp);
  fwrite( tx,    sizeof(tx),    1, fp);
  fwrite( ty,    sizeof(ty),    1, fp);
  fwrite( tanka, sizeof(tanka), 1, fp);
  fwrite( ds,    sizeof(ds),    1, fp);
  fwrite( es,    sizeof(es),    1, fp);
  fwrite( tr,    sizeof(tr),    1, fp);

  fprintf(fp, "%3d,%3d,%3d,%3d,", sp, sa, ja, jb);
  fprintf(fp, "%3d,%3d,", v, pgy_sw );
  fprintf(fp, "%4d,%4d", sum_p, sum_a);

  fclose(fp);
  loop_m(lb);
}

loadd()
{
  FILE *fp;

  if ( ( fp = fopen("xfleet.dat", "rb") ) == NULL ) {
    fprintf(stderr,"%s\n",fcx);
    exit(1);
  }
  fread( algo,  sizeof(algo),  1, fp);
  fread( prot,  sizeof(prot),  1, fp);
  fread( hikou, sizeof(hikou), 1, fp);
  fread( nenryo,sizeof(nenryo),1, fp);
  fread( gnen,  sizeof(gnen),  1, fp);
  fread( senko, sizeof(senko), 1, fp);
  fread( flg_p,  sizeof(flg_p),  1, fp);
  fread( flg_a,  sizeof(flg_a),  1, fp);
  fread( tx,    sizeof(tx),    1, fp);
  fread( ty,    sizeof(ty),    1, fp);
  fread( tanka, sizeof(tanka), 1, fp);
  fread( ds,    sizeof(ds),    1, fp);
  fread( es,    sizeof(es),    1, fp);
  fread( tr,    sizeof(tr),    1, fp);

  fscanf(fp, "%3d,%3d,%3d,%3d,", &sp, &sa, &ja, &jb);
  fscanf(fp, "%3d,%3d,", &v, &pgy_sw);
  fscanf(fp, "%4d,%4d", &sum_p, &sum_a);

  fclose(fp);
}
/*======================================================*/
sub_s()
{
  int i;

  ws = XCreateSimpleWindow(disp,wind,6*8,3*16,220,170,2,1,color[17]);
  XSelectInput(disp,ws,ExposureMask);

  butt[0] = XCreateSimpleWindow(disp,ws,10,66,18,18,1,1,color[13]);
  butt[1] = XCreateSimpleWindow(disp,ws,10,110,18,18,1,1,color[13]);
  butt[2] = XCreateSimpleWindow(disp,ws,38,66,18,18,1,1,color[13]);
  butt[3] = XCreateSimpleWindow(disp,ws,38,110,18,18,1,1,color[13]);
  butt[4] = XCreateSimpleWindow(disp,ws,89,66,18,18,1,1,color[13]);
  butt[5] = XCreateSimpleWindow(disp,ws,66,89,18,18,1,1,color[13]);
  butt[6] = XCreateSimpleWindow(disp,ws,112,89,18,18,1,1,color[13]);
  butt[7] = XCreateSimpleWindow(disp,ws,89,110,18,18,1,1,color[13]);

  butt[8] = XCreateSimpleWindow(disp,ws,155,66,18,18,1,1,color[13]);
  butt[9] = XCreateSimpleWindow(disp,ws,155,110,18,18,1,1,color[13]);
  butt[10] = XCreateSimpleWindow(disp,ws,183,66,18,18,1,1,color[13]);
  butt[11] = XCreateSimpleWindow(disp,ws,183,110,18,18,1,1,color[13]);

  butt[12] = XCreateSimpleWindow(disp,ws,90,136,35,18,1,1,color[13]);
  butt[13] = XCreateSimpleWindow(disp,ws,145,136,35,18,1,1,color[13]);
  for (i = 0; i < BUT; i++)
    XSelectInput(disp,butt[i],ButtonPressMask | ExposureMask |
		 EnterWindowMask | LeaveWindowMask);
  XMapSubwindows(disp,ws);
}

loop_s()
{
  XEvent e;
  int sw;

  if (sp > 10) {
    if (prot[KOU][sp] > nenryo[sp-NEN] )
      max = nenryo[sp - NEN];
    else
      max = prot[KOU][sp];
  }
  else if (sp == 5) {
    if (prot[KOU][sp] > gnen[0])
      max =gnen[0];
    else
      max = prot[KOU][sp];
  }
  else
    max = prot[KOU][sp];
  soku = max;
  houi = 90;
  while(1) {
    XNextEvent(disp, &e);
    switch(e.type) {
    case Expose:
      draw_s(&e);
      op_s();
      XWarpPointer(disp,None,ws,0,0,0,0,110,140);
      break;
    case EnterNotify:
      draw_sa(&e,REVERS);
      break;
    case LeaveNotify:
      draw_sa(&e,NORMAL);
      break;
    case ButtonPress:
      sw = hitb_s(&e);
      if (sw == END || sw == QUI) {
	cl_s();
	return sw;
      }
      break;
    }
  }
}

draw_s(eve)
     XExposeEvent *eve;
{
  int i;

  XSetForeground(disp,gc,color[0]);
  sprintf(bf,"%s %s",kansyu[prot[16][sp]], kanmei_p[sp] );
  XmbDrawString(disp,ws,fs,gc,10,24,bf,strlen(bf));
  sprintf(bf," > ");
  XmbDrawString(disp,ws,fs,gc,10,52,bf,strlen(bf));
  sprintf(bf,"%d", houi);
  XDrawString(disp,ws,fgc,58,52,bf,strlen(bf));
  XmbDrawString(disp,ws,fs,gc,15,103,"10",2);
  XmbDrawString(disp,ws,fs,gc,43,103,"1",1);
  sprintf(bf,"® > ");
  XmbDrawString(disp,ws,fs,gc,145,52,bf,strlen(bf));
  sprintf(bf,"%d", soku );
  XDrawString(disp,ws,fgc,192,52,bf,strlen(bf));
  sprintf(bf,"Max = ");
  XmbDrawString(disp,ws,fs,gc,150,25,bf,strlen(bf));
  sprintf(bf,"%d", max );
  XDrawString(disp,ws,fgc,192,25,bf,strlen(bf));
  XmbDrawString(disp,ws,fs,gc,160,103,"10",2);
  XmbDrawString(disp,ws,fs,gc,188,103,"1",1);
  XDrawLine(disp,ws,gc,140,10,140,128);

  for (i = 0; i < BUT; i++) {
    if (eve->window == butt[i]) {
      XSetWindowBackground(disp,butt[i],color[13]);
      XClearWindow(disp,butt[i]);
      XmbDrawString(disp,butt[i],fs,gc,2,14,
		    b_name[i],strlen(b_name[i]));
    }
  }
}

draw_sa(eve,mode)
     XCrossingEvent *eve;
     int mode;
{
  int i;
  GC agc;

  for (i = 0; i < BUT; i++) {
    if (eve->window == butt[i]) {
      if (mode == NORMAL) {
	XSetWindowBackground(disp,butt[i],color[13]);
	agc = gc;
      }
      else {
	XSetWindowBackground(disp,butt[i],color[16]);
	agc = rgc;
      }
      XClearWindow(disp,butt[i]);
      XmbDrawString(disp,butt[i],fs,agc,2,14,
		    b_name[i],strlen(b_name[i]));
      return;
    }
  }
}

hitb_s(e)
     XButtonEvent *e;
{
  int i;

  if (e->button == Button1) {
    for (i = 0; i < BUT; i++) {
      if (e->window == butt[i]){
	if (i == 12)
	  return END;
	else if (i == 13)
	  return QUI;

	else if(i == 0)
	  houi += 10;
	else if (i == 1)
	  houi -= 10;
	else if (i == 2)
	  houi += 1;
	else if (i == 3)
	  houi -= 1;
	else if (i == 4)
	  houi = 90;
	else if (i == 5)
	  houi = 180;
	else if (i == 6)
	  houi = 0;
	else if (i == 7)
	  houi = 270;

	else if (i == 8)
	  soku += 10;
	else if (i == 9)
	  soku -= 10;
	else if (i == 10)
	  soku += 1;
	else if (i == 11)
	  soku -= 1;

	if (soku > max)
	  soku = 0;
	else if (soku < 0)
	  soku = max;

	if (houi > 360)
	  houi -=360;
	else if (houi < 0)
	  houi +=360;

	XClearWindow(disp,ws);
	draw_s(&e);
      }
    }
  }
}

op_s()
{
  XMapWindow(disp,ws);
}

cl_s()
{
  XUnmapWindow(disp,ws);
}
/*------------------------------------------------------*/
sub_t()
{
  int i;

  wt = XCreateSimpleWindow(disp,wind,10,23*16+6,204,20,2,1,0);
  XSelectInput(disp,wt,ExposureMask);

  togl[0] = XCreateSimpleWindow(disp,wt,0,0,100,18,1,1,color[14]);
  togl[1] = XCreateSimpleWindow(disp,wt,102,0,100,18,1,1,color[14]);
  for (i = 0; i < TOG; i++)
    XSelectInput(disp,togl[i],ButtonPressMask | ExposureMask |
		 EnterWindowMask | LeaveWindowMask);

  XMapSubwindows(disp,wt);
}

op_t()
{
  XSetForeground(disp,gc,color[0]);
  XMapWindow(disp,wt);
}

cl_t()
{
  XUnmapWindow(disp,wt);
}

draw_t(e,lb)
     XExposeEvent *e;
     char *lb[];
{
  int i;

  op_t();
  XSetForeground(disp,gc,color[0]);
  for( i = 0; i < TOG; i++) {
    if (e->window == togl[i]) {
      XSetWindowBackground(disp,togl[i],color[14]);
      XClearWindow(disp,togl[i]);
      XmbDrawString(disp,togl[i],fs,gc,3,14,
		    lb[i],strlen(lb[i]));
      return;
    }
  }
  XWarpPointer(disp,None,wt,0,0,0,0,98,8);
}

draw_ta(e,lb,mode)
     XCrossingEvent *e;
     char *lb[];
     int mode;
{
  int i;
  GC agc;

  for (i = 0; i < TOG; i++) {
    if (e->window == togl[i]) {
      if (mode == NORMAL) {
	XSetWindowBackground(disp,togl[i],color[14]);
	agc = gc;
      }
      else {
	XSetWindowBackground(disp,togl[i],color[16]);
	agc = rgc;
      }
      XClearWindow(disp,togl[i]);
      XmbDrawString(disp,togl[i],fs,agc,3,14,
		    lb[i],strlen(lb[i]));
      return;
    }
  }
}

sub_r()
{
  wr = XCreateSimpleWindow(disp,wind,5*8,23*16+14,68,16,1,
			   color[6],color[18]);
  XSelectInput(disp,wr,ExposureMask);
}

op_r()
{
  XMapWindow(disp,wr);
}

cl_r()
{
  XUnmapWindow(disp,wr);
}
/*------------------------------------*/
loop_m(char *mese)
{
  XEvent e;

  XSetForeground(disp,gc,color[7]);
  op_m(mese);
  while(1) {
    XNextEvent(disp, &e);
    switch(e.type) {
    case Expose:
      XmbDrawString(disp,wm,fs,gc,4,16,mese,strlen(mese));
      break;
    case ButtonPress:
      if (e.xbutton.button == Button3) {
	cl_m();
	return;
      }
      break;
    }
  }
}

loop_i(char *mese)
{
  XEvent e;

  XSetForeground(disp,gc,color[7]);
  op_i(mese);
  while(1) {
    XNextEvent(disp, &e);
    switch(e.type) {
    case Expose:
      XmbDrawString(disp,wi,fs,gc,3,14,lb_i,strlen(lb_i));
      XmbDrawString(disp,wi,fs,gc,3,16+14,mese,strlen(mese));
      break;
    case ButtonPress:
      if (e.xbutton.button == Button3) {
	cl_i();
	return;
      }
      break;
    }
  }
}

op_m(char *mes)
{
  XRectangle ink, log;
  int rx, ry;

  XmbTextExtents(fs,mes,strlen(mes), &ink, &log);
  rx = log.width + 8;
  ry = log.height + 8;

  wm = XCreateSimpleWindow(disp,wind,25*8,20*16,rx,ry,2,
			   color[6],color[18]);
  XSelectInput(disp,wm,ExposureMask);
  XMapWindow(disp,wm);
  XDefineCursor(disp,wind,curs_m);
}

cl_m()
{
  XUndefineCursor(disp,wind);
  XDestroyWindow(disp,wm);
}

op_i(char *mes)
{
  XRectangle ink, log;
  int rx, ry;

  if (strlen(lb_i) > strlen(mes))
    XmbTextExtents(fs,lb_i,strlen(lb_i), &ink, &log);
  else
    XmbTextExtents(fs,mes,strlen(mes), &ink, &log);
  rx = log.width + 6;
  ry = log.height * 2 + 6;
  wi = XCreateSimpleWindow(disp,wind,25*8,15*16+2,rx,ry,2,
			   color[6],color[18]);
  XSelectInput(disp,wi,ExposureMask);
  XMapWindow(disp,wi);
}

cl_i()
{
  XDestroyWindow(disp,wi);
}
/*--------------------------*/
itoa(int n)
{
  sprintf(buff, "%d", n);
}
/*-------------------------------------------*/
ini()
{
  int i, j;

  for (i = 0; i < 17; i++) {
    for (j = 0; j < MAXK; j++) {
      algo[i][j] = prot[i][j];
    }
  }
  for (i = 0; i < 2; i++) {
    for ( j = 0; j < MAXK; j++) {
      algo[i+X][j] = alg[i][j];
    }
  }
  for (i = 0; i < 28; i++) {
    if (i > 6 && i < 14)
      nenryo[i] = nen[i-7];
    else if (i > 13 && i < 21)
      nenryo[i] = nen[i-14];
    else if (i > 20)
      nenryo[i] = nen[i-21];
    else
      nenryo[i] = nen[i];
  }
  for (i = 7; i < 14; i++) {
    hikou[i] = (int)((double)nenryo[i]/(double)prot[KOU][i + NEN]+1);
  }
  for (i = 21; i < 28; i++) {
    hikou[i] = (int)((double)nenryo[i]/(double)algo[KOU][i - 10]+1);
  }
  for (i = 0; i < NEN; i++)
    gnen[i] = 300;
  senko[1] = senko[3] = 2;

  srand((unsigned)time(NULL));
  i = (int)(rnd() * 3);
  if (i == 0) {
    tx[0] = 70; tx[2] = 20; tx[4] = 180; tx[6] = 120;
    tx[1] = 380; tx[3] = 420; tx[7] = 310; tx[8] = 350;
  }
  else if (i == 1) {
    tx[0] = 40; tx[1] =100; tx[2] = 20; tx[3] = 70;
    tx[4] = 140; tx[6] = 120; tx[7] = 160; tx[8] = 180;
  }
  else {
    tx[0] = 380; tx[1] = 420; tx[2] = 400; tx[3] = 430;
    tx[4] = 340; tx[6] = 320; tx[7] = 360; tx[8] = 180;
  }
  for (i = 0; i < 9; i++) {
    if (i != 5)
      ty[i] = 250;
  }
}
/*----------------------------------*/
MyColor(d, c)
     Display *d;
     char    *c;
{
  Colormap cmap;
  XColor c0, c1;

  cmap = DefaultColormap(d, 0);
  XAllocNamedColor(d, cmap, c, &c1, &c0);
  return(c1.pixel);
}

datadisp()
{
  int i, j;

  gxcls();
  for (i = 0; i < MAXK; i++) {
    sprintf(bf,"%2d ", i);
    for (j = 0; j < 17; j++) {
      sprintf(buff,"%4d ",prot[j][i]);
      strcat(bf,buff);
    }
    XmbDrawString(disp,wind,fs,gc,2,i*16+14,bf,strlen(bf));
  }
  loop_r();
  /*	gxcls();
    for (i = 0; i < MAXK; i++) {
    sprintf(bf,"%2d ", i);
    for (j = 0; j < 17; j++) {
    sprintf(buff,"%4d ",algo[j][i]);
    strcat(bf,buff);
    }
    XmbDrawString(disp,wind,fs,gc,2,i*16+14,bf,strlen(bf));
    }
    loop_r();
  */
}
/*-----------------------------------------------------*/
fight()
{
  int i, n, x1, u, x, y, r1, v1, z;
  int jj, rr;
  char *lb1 = "Can not Inspect.";
  char *lb2 = "Noting.";
  char *lb3 = "Ʈ   Open Hostility.";

  gxcls();
  f_mae();
  x = prot[X][sp];
  y = prot[Y][sp];
  if (sp > 10 && sp < KOMA) {
    if (hikou[sp-HIKO] == 0) {
      loop_m(lb1);
      return 0;
    }
  }
  r1 = hoko(x, y, &v1);
  if (r1 == 0) {
    loop_m(lb2);
    return 0;
  }
  n = f_inp(v1, r1, x, y);
  if (n < 0)
    return 0;

  gxcls();
  XmbDrawString(disp,wind,fs,gc,15*8,10*16+14,lb3,strlen(lb3));
  z = (int)fna(x, y, algo[X][ds[n] ], algo[Y][ds[n] ] );
  x1 = ds[n];
  info();
  XBell(disp,-80);

  jj = fnj(prot[MEI][sp], prot[YUU][sp], z);
  rr = rnd()*100;
  if (jj > rr) {
    u = senkoji(x1, 2);
    mei(ALG, x1, sp, u);
    algo[TAI][x1] = tai(ALG, x1, sp, u);
    if ( algo[TAI][x1] < 1 ) {
      algo[KATI][x1] = -1;
      strcpy(bf,bun[18]);
      if (x1 == 6 || x1 == 7) {
	for (i = HIKO; i < KOMA; i++) {
	  if (hikou[i+3] == 0 && bokan[i-HIKO] == x1)
	    algo[KATI][i] = -1;
	}
      }
      if (x1 > 17)
	strcat(bf,city[x1-KOMA]);
      else
	strcat(bf, kansyu[algo[SYU][x1]]);
      strcat(bf, kanmei_a[x1]);
      strcat(bf, bun[20]);
      if (x1 < KOMA && x1 > 10) {
	hikou[x1+3] = 0;
	strcat(bf, bun[21]);
      }
      if (x1 < HIKO)
	strcat(bf, bun[22]);
      if (x1 > 17)
	strcat(bf, bun[23]);
      XmbDrawString(disp,wind,fs,gc,10*8,16*16+14,bf,strlen(bf));
      goto end;
    }
    else {
      hak(ALG, x1);
      strcpy(bf, bun[18]);
      if (x1 < KOMA)
	strcat(bf, kansyu[algo[SYU][x1]]);
      else
	strcat(bf, city[x1-KOMA]);
      strcat(bf, kanmei_a[x1]);
      strcat(bf, bun[19]);
      XmbDrawString(disp,wind,fs,gc,10*8,16*16+14,bf,strlen(bf));
    }
  }
  else
    XmbDrawString(disp,wind,fs,gc,10*8,16*16+14,bun[17],strlen(bun[17]));
  if(x1 < KOMA && x1 != 9 && x1 != 10 ||
     algo[ prot[SYU][sp]+4][x1] < 1 || algo[YUU][x1] < z )
    goto end;
  else {
    u = senkoji(sp, 0);
    if (fnj(algo[MEI][x1], algo[YUU][x1], z) >= rnd()*100 )
      goto end;
    mei(PRT, sp, x1, u);
    if (tai(PRT,sp, x1, u) <= 0) {
      prot[KATI][sp] = -1;
      XmbDrawString(disp,wind,fs,gc,10*8,17*16+14,bun[24],strlen(bun[24]));
    }
    else {
      prot[TAI][sp] = tai(PRT, sp, x1, u);
      XmbDrawString(disp,wind,fs,gc,10*8,17*16+14,bun[25],strlen(bun[25]));
    }
    hak(PRT, sp);
  }
 end:
  if ( sp == 4 && senko[0] > 0 )
    senko[0]++;
  if (sp < KOMA && sp > 10 ) {
    if (hikou[sp-HIKO] > 0)
      hikou[sp-HIKO]++;
  }
  loop_r();
  return 1;
}

f_mae()
{
  char *lb1 = "--- Central Infomation Center ---";
  char *lb2 = "This is Automatic Multarea Inspection.";
  char *lb3 = "ưٲƥ ưϤޤ.";
  char *lb4 = " ----  Report  ----";

  sprintf(bf,"---- %s  %s ----",
	  kansyu[prot[SYU][sp] ], kanmei_p[sp] );
  XmbDrawString(disp,wind,fs,gc,20*8,1*16+14,bf,strlen(bf));
  XmbDrawString(disp,wind,fs,gc,25*8,2*16+14,lb1,strlen(lb1));
  XmbDrawString(disp,wind,fs,gc,5*8,3*16+14,lb2,strlen(lb2));
  XmbDrawString(disp,wind,fs,gc,5*8,4*16+14,lb3,strlen(lb3));
  XmbDrawString(disp,wind,fs,gc,1*8,5*16+14,lb4,strlen(lb4));
}

senkoji(int num, int sen)
{
  if (num == 4 && senko[sen] == 0)
    return 8;
  else
    return 1;
}

hoko(int x,int y, int *vv)
{
  int i, a, b, z, r = 0, v = 0;
  char *ptr;
  char *br = "---------------------------------------------------------------------------";

  for (i = 0; i < MAXK; i++) {
    a = algo[X][i];
    b = algo[Y][i];
    z = (int)fna(x, y, a, b);
    if (i > 10 && i < KOMA) {
      if (hikou[i + 3] == 0)
	continue;
    }
    if (i == 4) {
      if (senko[2] > 0) {
	if (sp < 2 || sp > 4)
	  continue;
      }
    }
    if (algo[KATI][i] < 0)
      continue;
    if( xy(x, y, a, b) ) {
      if ((r % 6 ) == 4 && r > 1) {
	loop_r();
	gxcls();
      }
      sprintf(bf,"%s %s",bun[ houii(x,y,a,b) ], bun[8] );
      strcpy(buff,bf);
      if (i < KOMA )
	sprintf(bf,"  %s  %s",kansyu[ algo[SYU][i] ], kanmei_a[ i ] );
      else
	sprintf(bf,"  %s  %s",city[i-KOMA], kanmei_a[ i ] );
      strcat(buff,bf);
      sprintf(bf,"  %s ( %3d ) Code# %d",bun[9], z, r);
      strcat(buff,bf);
      XmbDrawString(disp,wind,fs,gc,2,((r+2)%6)*4*16+14,buff,strlen(buff));

      if (z <= prot[YUU][sp]) {
	*vv = ++v;
	ptr = bun[11];
      }
      else
	ptr = bun[10];
      sprintf(bf," %s  %s  %3.0f",bun[12], ptr,fabs(prot[YUU][sp] - z) );
      strcpy(buff,bf);
      if (z <= prot[YUU][sp]) {
	sprintf(bf,"  %s  %2d  %s %3.0f%%  %s  %2d",
		bun[13], prot[ algo[SYU][i]+4 ][sp] ,bun[14],
		fnj( prot[MEI][sp], prot[YUU][sp], z),
		bun[15], prot[TAI][sp]);
      }
      else
	sprintf(bf,"");
      strcat(buff,bf);
      XmbDrawString(disp,wind,fs,gc,2,(((r+2)%6)*4+1)*16+14,buff,strlen(buff));

      sprintf(bf,"%s", bun[16]);
      strcpy(buff,bf);
      if (z <= algo[YUU][i])
	ptr = bun[11];
      else
	ptr = bun[10];
      sprintf(bf," %3.0f  %s  %2d", fabs(algo[YUU][i]-z),
	      bun[13], algo[prot[SYU][sp]+4 ][i]);
      strcat(buff,bf);
      if (z <= algo[YUU][i]) {
	sprintf(bf,"  %s%3.0f%%",
		bun[14], fnj(algo[MEI][i], algo[YUU][i], z));
	strcat(buff,bf);
      }
      sprintf(bf,"  %s  %2d", bun[15], algo[TAI][i]);
      strcat(buff,bf);
      XmbDrawString(disp,wind,fs,gc,2,(((r+2)%6)*4+2)*16+14,buff,strlen(buff));
      XmbDrawString(disp,wind,fs,gc,2,(((r+2)%6)*4+3)*16+14,br,strlen(br));

      ds[r] = i;
      r++;
    }
  }
  return r;
}

houii(int x, int y, int a, int b)
{
  int n;

  if (b <= y && b <=fnh(-x, y, -a) && b <= fnh(x,y,a) )
    n = 0;
  else if (b >= y && b >= fnh(-x,y,-a) && b >=fnh(x,y,a) )
    n = 1;
  else if (a >=x && b >=fni(x,y,a) && b <=fni(-x,y,-a) )
    n = 2;
  else if (a <= x && b >=fni(-x,y,-a) && b <=fni(x,y,a) )
    n = 3;
  else if (a >= x) {
    if (b <= y)
      n = 4;
    else
      n = 5;
  }
  else if (a <= x) {
    if (b <= y)
      n = 6;
    else
      n = 7;
  }
  return n;
}

f_inp(int v1, int r1, int x, int y)
{
  XEvent e;
  char *lb[] = {"Fight","Return",};

  while(1) {
    XNextEvent(disp, &e);
    switch(e.type) {
    case Expose:
      draw_t(&e,lb);
      break;
    case EnterNotify:
      draw_ta(&e,lb,REVERS);
      break;
    case LeaveNotify:
      draw_ta(&e,lb,NORMAL);
      break;
    case ButtonPress:
      if (hit_but_f(&e,v1,r1,x,y) == END)
	return enmy;
      break;
    }
  }
}

hit_but_f(eve, v, r, x, y)
     XButtonEvent *eve;
     int v, r, x, y;
{
  int i, sw;
  char *lb1 = "Return Only.";

  if (eve->button == Button1) {
    for (i = 0; i < TOG; i++) {
      if (eve->window == togl[i]) {
	cl_t();
	if (i == 0 && v == 0) {
	  loop_m(lb1);
	}
	if (i == 1) {
	  enmy = -1;
	  return END;
	}
	else {
	  sw = inp_code(r, x, y);
	  if (sw == END)
	    return END;
	}
      }
    }
  }
}

inp_code(r, x, y)
     int r, x, y;
{
  XEvent e;
  int sw;
  double aa;
  char *lb = "Can not Fight.";

  enmy = 0;
  while(1) {
    XNextEvent(disp, &e);
    switch(e.type) {
    case Expose:
      op_f();
      draw_f(&e,r);
      XWarpPointer(disp,None,wf,0,0,0,0,60,50);
      break;
    case EnterNotify:
      draw_fa(&e,REVERS);
      break;
    case LeaveNotify:
      draw_fa(&e,NORMAL);
      break;
    case ButtonPress:
      sw = hitb_f(&e,r);
      if ( sw == END) {
	aa = fna(x, y, algo[X][ds[enmy]], algo[Y][ds[enmy]]);
	if (aa > prot[YUU][sp] ||
	    prot[algo[SYU][ds[enmy]]+4][sp] < 1) {
	  loop_m(lb);
	  enmy = -1;
	}
	cl_f();
	return END;
      }
      break;
    }
  }
}

hitb_f(eve,r)
     XButtonEvent *eve;
     int r;
{
  int i;

  if(eve->button == Button1) {
    for(i = 0; i < COD;i++) {
      if (eve->window == code[i]) {
	if (i == 2) {
	  return END;
	}
	else if (i == 3) {
	  enmy = -1;
	  return END;
	}
	else if (i == 0)
	  enmy += 1;
	else if (i == 1)
	  enmy -= 1;

	if (enmy < 0)
	  enmy = r - 1;
	else if (enmy > r - 1)
	  enmy = 0;
	XClearWindow(disp,wf);
	draw_f(&eve,r);
      }
    }
  }
}

sub_f()
{
  int i;

  wf = XCreateSimpleWindow(disp,wind,8*8,7*16,120,108,2,1,color[12]);
  XSelectInput(disp,wf,ExposureMask);

  code[0] = XCreateSimpleWindow(disp,wf,87,29,18,18,1,1,color[13]);
  code[1] = XCreateSimpleWindow(disp,wf,87,57,18,18,1,1,color[13]);
  code[2] = XCreateSimpleWindow(disp,wf,5,85,30,18,1,1,color[13]);
  code[3] = XCreateSimpleWindow(disp,wf,55,85,50,18,1,1,color[13]);
  for (i = 0; i < COD; i++)
    XSelectInput(disp,code[i],ButtonPressMask | ExposureMask |
		 EnterWindowMask | LeaveWindowMask);
  XMapSubwindows(disp,wf);
}

op_f()
{
  XMapWindow(disp,wf);
}

cl_f()
{
  XUnmapWindow(disp,wf);
}

draw_f(eve, r)
     XExposeEvent *eve;
     int r;
{
  int i;
  char *lb1 = "Input Code";

  XSetForeground(disp,gc,color[0]);
  XmbDrawString(disp,wf,fs,gc,15,5+14,lb1,strlen(lb1));
  sprintf(bf,"MAX # = ");
  XmbDrawString(disp,wf,fs,gc,5,29+14,bf,strlen(bf));
  sprintf(bf,"%d",r-1);
  XDrawString(disp,wf,fgc,64,29+14,bf,strlen(bf));
  sprintf(bf,"Select > ");
  XmbDrawString(disp,wf,fs,gc,5,57+14,bf,strlen(bf));
  sprintf(bf,"%d",enmy);
  XDrawString(disp,wf,fgc,69,57+14,bf,strlen(bf));
  for (i = 0; i < COD; i++) {
    if (eve->window == code[i]) {
      XSetWindowBackground(disp,code[i],color[13]);
      XClearWindow(disp,code[i]);
      XmbDrawString(disp,code[i],fs,gc,1,14,f_name[i],strlen(f_name[i]));
    }
  }
}

draw_fa(eve, mode )
     XCrossingEvent *eve;
     int mode;
{
  int i;
  GC agc;

  for (i = 0; i < COD; i++) {
    if (eve->window == code[i]) {
      if (mode == NORMAL) {
	XSetWindowBackground(disp,code[i],color[13]);
	agc = gc;
      }
      else {
	XSetWindowBackground(disp,code[i],color[16]);
	agc = rgc;
      }
      XClearWindow(disp,code[i]);
      XmbDrawString(disp,code[i],fs,agc,1,14,f_name[i],strlen(f_name[i]));
      return;
    }
  }
}
/*----------------------------------------------*/
mei(int a, int b, int c, int d)
{
  if (a == PRT) {
    prot[MEI][b] = (int)(prot[MEI][b] * (double)tai(PRT, b, c, d) /
			 (double)prot[TAI][b]);
  } else if (a == ALG) {
    algo[MEI][b] = (int)(algo[MEI][b] * (double)tai(ALG, b, c, d) /
			 (double)algo[TAI][b]);
  }
}

hak(int a, int b)
{
  int i;

  if (a == PRT) {
    for (i = 1; i < KATI; i++) {
      if (i == 3)
	continue;
      prot[i][b] = (int)(prot[i][b] * (rnd()*20 + 80) / 100.0);
    }
  } else if (a == ALG) {
    for (i = 1; i < KATI; i++) {
      if (i == 3)
	continue;
      algo[i][b] = (int)(algo[i][b] * (rnd()*20 + 80) / 100.0);
    }
  }
}

tai(int a, int b, int c, int d)
{
  if (a == PRT)
    return ( prot[TAI][b] - algo[ prot[SYU][b]+4][c] * d );
  else if (a == ALG)
    return ( algo[TAI][b] - prot[ algo[SYU][b]+4][c] * d );
}
/*------------------------------------------------------*/
kazo()
{
  int i, x = 0;

  for (i = 0; i < KOMA; i++) {
    if (flg_a[i] == 1)
      x++;
  }
  return x;
}

algon(int x)
{
  int i, u, n;

  gxcls();
  sprintf(bf,"UNITED ALGONS NAVY ... ACTION ");
  XmbDrawString(disp,wind,fs,gc,25*8,13*16+14,bf,strlen(bf));
  sprintf(bf,"%d", x);
  XDrawString(disp,wind,fgc,52*8,13*16+14,bf,strlen(bf));

  if (ja == 1 || tr[5] < 4)
    u = 1;
  else
    u = 0;
  for(i = u; i < 2; i++) {
    for (sa = 0; sa < KOMA; sa ++) {
      if (algo[KATI][sa] < 0 || flg_a[sa] == 1) {
	flg_a[sa] = 1;
	continue;
      }
      if (sa > 10) {
	if (hikou[sa+3] == 0 || hikou[sa+10]-hikou[sa+3] <= 1) {
	  if (i == 1) {
	    flg_a[sa] = 1;
	    alg_m();
	    return;
	  }
	  else
	    continue;
	}
      }
      if (sa == 9 || sa == 10) {
	if (i == 1) {
	  alg_y();
	  return;
	}
	else
	  continue;
      }
      if (sa == 4 && senko[2] == senko[3]) {
	if (i == 1) {
	  flg_a[sa] = 1;
	  alg_m();
	  return;
	}
	else
	  continue;
      }
      n = alg_n();
      if (n == -1 && i == 1) {
	flg_a[sa] = 1;
	alg_m();
	return;
      }
      if (n > -1) {
	flg_a[sa] = 1;
	if (sa == 4 && senko[2] == senko[3])
	  alg_m();
	else
	  alg_f(n);
	return;
      }
    }
  }
}

alg_n()
{
  int i, n = -1;
  double aa;

  for (i = 0; i < MAXK ; i++) {
    if ((prot[KATI][i] < 0) || (sa == 5 && i > 17))
      continue;
    if (i > 10 && i < KOMA) {
      if (hikou[i-HIKO] == 0)
	continue;
    }
    if ((sa < 2 || sa > 4 ) && (i == 4) && (senko[0] > 0))
      continue;
    aa = fna(prot[X][i], prot[Y][i], algo[X][sa], algo[Y][sa]);
    if ( aa < algo[YUU][sa] ) {
      n++;
      es[n] = i;
    }
  }
  return n;
}

alg_m()
{
  int x, y, x1, y1, r;

  x = algo[X][sa];
  y = algo[Y][sa];
  if ( sa == 5 && gnen[2] < 45 )
    alg_g(x, y);
  if ( sa > 10 && (hikou[sa+10] - hikou[sa+3] <= 1) )
    alg_a(x, y);

  for (r = 0; r < MAXK ; r++) {
    if (prot[KATI][r] < 0)
      continue;
    if (r > 10 && r < KOMA) {
      if (hikou[r-HIKO] == 0)
	continue;
    }
    else {
      if (sa == 5 && r > KOMA)
	continue;
    }
    if (r == 4) {
      if ((sa < 2 || sa > 4 ) && (senko[r-NEN] > 0))
	continue;
    }
    x1 = prot[X][r];
    y1 = prot[Y][r];
    if ( xy(x, y, x1, y1 ) ) {
      if ( alg_v(x, y, x1, y1, r) < 1 )
	return;
      else
	break;
    }
  }
  if (sa < 9 && sa != 5)
    alg_s(x, y);
  else if (sa == 5)
    alg_g(x, y);
  else if (sa > 10)
    alg_a(x, y);
}

xy(int x, int y,int x1, int y1)
{
  if (x - 72 < x1 && x + 72 > x1 && y - 45 < y1 && y + 45 > y1)
    return 1;
  else
    return 0;
}
alg_s(int x, int y)
{
  int i;

  if (x == tx[sa] && y == ty[sa]) {
    if (tr[sa] == 0) {
      tx[sa] = 320;
      ty[sa] = 408;
      tr[sa] = 1;
    }
    else {
      if (tr[sa] == 1) {
	tx[sa] = 200;
	ty[sa] = 80;
      }
    }
  }
  alg_h(x, y, tx[sa], ty[sa]);
  if (sa == 4)
    alg_p(x, y);
  else if (sa > 6 && sa < 10) {
    for (i = HIKO; i < KOMA; i++) {
      if (hikou[i+3] == 0 && bokan[i-HIKO] == sa) {
	algo[X][i] = algo[X][bokan[i-HIKO]];
	algo[Y][i] = algo[Y][bokan[i-HIKO]];
      }
    }
  }
}

alg_p(int x, int y)
{
  if (senko[2] == senko[3]) {
    senko[2] = 0;
    alg_h(x, y,tx[sa], ty[sa]);
  }
  else {
    senko[2]++;
    alg_h(x, y,tx[sa], ty[sa]);
  }
}

alg_g(int x, int y)
{
  int GYO = 5, mx = 225, my = 61, nx = 120, ny = 110;

  if (algo[X][GYO] == nx && algo[Y][GYO] == ny) {
    pgy_sw = 1;
    gnen[2] = gnen[3];
    alg_h(x, y, mx, my);
  }
  else {
    if (pgy_sw == 0) {
      gnen[2] -= alg_h(x, y, nx, ny);
    }
    if (algo[X][GYO] == mx && algo[Y][GYO] == my) {
      pgy_sw = 0;
      gnen[2] = gnen[3];
      alg_h(x, y, nx, ny);
    }
    if (pgy_sw == 1) {
      gnen[2] -= alg_h(x, y, mx, my);
    }
  }
}

alg_y()
{
  int x, y, ax = 479, ay = 130, bx = 406, by = 61;

  flg_a[sa] = 1;
  x = algo[X][sa];
  y = algo[Y][sa];
  if ( algo[KATI][21] < 0 )
    return;
  if (x == ax && y == ay) {
    alg_h(x, y, bx, by);
    tanka[sa-7] = 1;
  }
  else if (tanka[sa-7] != 1)
    alg_h(x, y, ax, ay);
  if (x == bx && y == by) {
    tanka[sa-7] = 0;
    sum_a += YUSO;
    alg_h(x, y, ax, ay);
  }
  else if (tanka[sa-7] == 1)
    alg_h(x, y, bx, by);
}

alg_h(int x, int y, int px, int py)
{
  int sx, sy, x1, y1, yn, z;

 Top:
  sx = x; sy = y; x1 = px; y1 = py;
  z = (int)fna(x, y, px, py);
  if (z > algo[KOU][sa])
    z = algo[KOU][sa];
  if (z != 0) {
    algo[X][sa] = (int)fnr(x, y, px, py, z);
    algo[Y][sa] = (int)fns(x, y, px, py, z);
    if (sa < HIKO) {
      yn = hani(algo[X][sa], algo[Y][sa]);
      if (yn == 4 || yn == 3 || yn == 1) {
	px = x1+(int)(rnd()*10-5)*100;
	py = y1+(int)(rnd()*10-5)*100;
	x = sx;
	y = sy;
	goto Top;
      }
    }
  }
  return z;
}

alg_a(int x, int y)
{
  int r, z, xa, ya;

  if (sa < HIKO)
    return;
  if (nenryo[sa+3] >= algo[KOU][sa])
    r = algo[KOU][sa];
  else
    r = nenryo[sa+3];
  xa = algo[X][ bokan[sa-HIKO] ];
  ya = algo[Y][ bokan[sa-HIKO] ];
  if (tx[ bokan[sa-HIKO] ] != 200) {
    tx[sa] = xa + (sa % 3) * 40 - 40;
    ty[sa] = ya + 60;
  }
  else {
    tx[sa] = xa + (sa % 3) * 30 - 30;
    ty[sa] = ya - 60;
  }
  if (algo[KATI][ bokan[sa-HIKO]] < 0 &&
      (hikou[sa+3] >= hikou[sa+10] || nenryo[sa+3] <= 0)) {
    algo[KATI][sa] = -1;
    return;
  }
  if (hikou[sa+3] >= hikou[sa+10] &&
      r < (int)fna(x, y, xa, ya )) {
    algo[KATI][sa] = -1;
    return;
  }
  if ( r < (int)fna(x, y, xa, ya ) ) {
    z = alg_h(x, y, xa, ya);
    hikou[sa+3]++;
    nenryo[sa+3] -= z;
    return;
  }
  if (hikou[sa+3] >= 2 && r >= (int)fna(x, y, xa, ya)
      && algo[KATI][ bokan[sa-HIKO] ] > 0) {
    algo[X][sa] = xa;
    algo[Y][sa] = ya;
    hikou[sa+3] = 0;
    nenryo[sa+3] = nenryo[sa+10];
    if (algo[TAI][sa] < 10) {
      algo[TAI][sa] = 8;
      algo[MEI][sa] = 40;
    }
    return;
  }
  if (hikou[sa+3] == 0) {
    z = alg_h(x, y, tx[sa], ty[sa]);
    hikou[sa+3]++;
    nenryo[sa+3] -= z;
  }
  if (hikou[sa+3] > 0) {
    hikou[sa+3]++;
  }
}

alg_f(int n)
{
  int i, f, r, u, x;
  char *lb = "Battle Action";

  x = alg_x(n, &f);
  r = es[x];
  /*	x = algo[X][sa];
    y = algo[Y][sa];
    a = prot[X][r];
    b = prot[Y][r];  */
  if ( algo[ prot[SYU][r]+4][sa] <= 0 ) {
    alg_m();
    return;
  }
  u = senkoji(r, 0);
  XmbDrawString(disp,wind,fs,gc,10*8,12*16+14,lb,strlen(lb));
  info();
  if (fnj(algo[MEI][sa], algo[YUU][sa], f) < rnd()*100) {
    alg_fm(r);
    strcat(bf,bun[29]);
    XmbDrawString(disp,wind,fs,gc,5*8,16*16+14,bf,strlen(bf));
  }
  else {
    mei(PRT, r, sa, u);
    if ( tai(PRT, r, sa, u) < 1 ) {
      prot[KATI][r] = -1;
      if (r > 5 && r < 9) {
	for (i = HIKO; i < KOMA; i++) {
	  if (hikou[i-HIKO] == 0 && bokan[i-HIKO] == r)
	    prot[KATI][i] = -1;
	}
      }
      alg_fm(r);
      strcat(bf, bun[28]);
      XmbDrawString(disp,wind,fs,gc,5*8,16*16+14,bf,strlen(bf));
      goto End;
    }
    else {
      prot[TAI][r] = tai(PRT,r, sa, u);
      hak(PRT, r);
      alg_fm(r);
      strcat(bf, bun[26]);
      XmbDrawString(disp,wind,fs,gc,5*8,16*16+14,bf,strlen(bf));
    }
  }
  if(r < KOMA && r != 9 && r != 10 ||
     prot[algo[SYU][sa]+4 ][r] < 1 || prot[YUU][r] < f)
    goto End;
  u = senkoji(sa, 2);
  if (fnj(prot[MEI][r], prot[YUU][r], f) >= rnd() * 100) {
    mei(ALG, sa, r, u);
    if ( tai(ALG, sa, r, u) <= 0 ) {
      algo[KATI][sa] = -1;
      XmbDrawString(disp,wind,fs,gc,5*8,17*16+14,bun[24],strlen(bun[24]));
    }
    else {
      algo[TAI][sa] = tai(ALG, sa, r, u);
      XmbDrawString(disp,wind,fs,gc,5*8,17*16+14,bun[30],strlen(bun[30]));
    }
    hak(ALG, sa);
  }
 End:
  if (sa > 10)
    hikou[sa+3]++;
  else if (sa == 4 && senko[2] > 0)
    senko[2]++;
}

alg_fm(int r)
{
  sprintf(bf,"%s %s %s %s %s", kansyu[prot[SYU][r]], kanmei_p[r],
	  bun[27], kansyu[algo[SYU][sa]], kanmei_a[sa]);
  XBell(disp,-80);
}

alg_x(int n, int *f)
{
  int i, maxim, num = 0;

  maxim = prot[MEI][es[0]];
  if (n < 1)
    num = 0;
  else {
    for (i = 1; i < n; i++) {
      if (prot[MEI][es[i]] > maxim) {
	maxim = prot[MEI][es[i]];
	num = i;
      }
    }
  }
  *f = (int)fna( prot[X][es[num]], prot[Y][es[num]],
		 algo[X][sa], algo[Y][sa]);
  return num;
}
/*	int i, j, sum, z;

for(i = 0; i <= n; i++) {
sum = 0;
for (j = 0; j <= n; j++) {
z = fna(prot[X][es[j] ], prot[Y][es[j] ],
algo[X][sa], algo[Y][sa] );
*f = fna(prot[X][es[i] ], prot[Y][es[i] ],
algo[X][sa], algo[Y][sa] );
if (*f <= z )
sum++;
}
if (n == sum - 1 )
break;
}
return i;
} */

alg_v(int x, int y, int x1, int y1, int r)
{
  int n, sx, sy, yn, i, z;

 Top:
  sx = x;
  sy = y;
  n = (int)fna(x,y,x1,y1);
  z = get_z(n, r);
  algo[X][sa] = (int)fnr(x,y,x1,y1,z);
  algo[Y][sa] = (int)fns(x,y,x1,y1,z);
  if (sa > 10 ) {
    if (nenryo[sa+3] - z < (int)fna(algo[X][sa], algo[Y][sa],
				    algo[X][bokan[sa-HIKO]],
				    algo[Y][bokan[sa-HIKO]])) {
      algo[X][sa] = sx;
      algo[Y][sa] = sy;
      return 1;
    }
  }
  if (sa == 5) {
    if (gnen[2] - z < (int)fna(algo[X][sa], algo[Y][sa],405,61) &&
	gnen[2] - z < (int)fna(algo[X][sa], algo[Y][sa], 225,61)) {
      algo[X][sa] = sx;
      algo[Y][sa] = sy;
      return 1;
    }
  }
  yn = hani(algo[X][sa], algo[Y][sa]);
  if ( sa < HIKO ) {
    if ( yn == 1 || yn == 3 || yn == 4 ) {
      x1 += (int)(rnd()*60 - 30);
      y1 += (int)(rnd()*60 - 30);
      x = sx;
      y = sy;
      goto Top;
    }
  }
  if (yn == 2) {
    x1 += (int)(rnd()*60 - 30);
    y1 += (int)(rnd()*60 - 30);
    x = sx;
    y = sy;
    goto Top;
  }
  if (sa == 4) {
    if (senko[2] == senko[3]) {
      senko[2] = 0;
      return 0;
    }
    else {
      senko[2]++;
      return 0;
    }
  }
  if (sa == 5) {
    gnen[2] -= z;
    if (gnen[2] <= 0)
      algo[KATI][5] = -1;
  }
  if (sa < 9 && sa > 5 ) {
    for (i = HIKO; i < KOMA; i++) {
      if (hikou[i-KATI] == 0 && bokan[i-HIKO] == sa) {
	algo[X][i] = algo[X][bokan[i-HIKO]];
	algo[Y][i] = algo[Y][bokan[i-HIKO]];
      }
    }
    return 0;
  }
  if (sa > 10 && sa < KOMA) {
    hikou[sa+3]++;
    nenryo[sa+3] -= z;
  }
  return 0;
}

get_z(int n, int r)
{
  int z;

  if (algo[ prot[SYU][r]+4 ][sa] > 0) {
    if (n - algo[YUU][sa]+3 <= algo[KOU][sa])
      z = n - algo[YUU][sa]+3;
    else
      z = algo[KOU][sa];
  }
  else {
    if (n - prot[YUU][r]-3 <= algo[KOU][sa])
      z = n - prot[YUU][r]-3;
    else
      z = algo[KOU][sa];
  }
  if (sa > 10) {
    if (nenryo[sa+3] < z)
      z = nenryo[sa+3];
  }
  if (sa == 5) {
    if (gnen[2] < z)
      z = gnen[2];
  }
  return z;
}
/*---------------------------- FIN ---------------------*/
